/*-----------------------------------------------------------------------------
	ClockPod / pDLL											(c)TORO
-----------------------------------------------------------------------------*/
#define ONDLL		// DLL `w
#define STRICT
#include <windows.h>
#include "CLOCKPOD.H"

HINSTANCE hDLLInst;
HWND hClockPodWnd = NULL;	// ClockPod {̂ hWnd
DWORD NowStatus = IME_CHECK;	// IME Ԃ̋L  = IME_NOTARGET:g
HHOOK hOldSendHook = NULL;
HHOOK hOldPostHook = NULL;
UINT WM_CLOCKPOD;
int DataGet = 0;

/*-----------------------------------------------------------------------------
	dll ̏^I
-----------------------------------------------------------------------------*/
#pragma argsused
BOOL WINAPI DLLEntry(HINSTANCE hInst, DWORD reason, LPVOID reserved)
{
	UnUsedParam(reserved);
	switch (reason){
		// DLL  ---------------------------------------------------------
		case DLL_PROCESS_ATTACH:
			hDLLInst = hInst;
			WM_CLOCKPOD = RegisterWindowMessageA(AppName);
			break;

		// DLL ̏I -----------------------------------------------------
//		case DLL_PROCESS_DETACH:
//			break;
	}
	return TRUE;
}

/*-----------------------------------------------------------------------------
	HOOK 
-----------------------------------------------------------------------------*/
void IMEcheck(HWND hTargetWnd, HWND hReportWnd)
{
	HIMC hIMC;
	DWORD cStatus, sStatus;
								// IME 
	hIMC = ImmGetContext(hTargetWnd);
	if ( hIMC == 0 ){
		cStatus = IME_DIABLE;
		if ( NowStatus & IME_CAPTIONCHANGE) DataGet = 1;
	}else{
		if ( ImmGetOpenStatus(hIMC) == FALSE ){
			cStatus = IME_OFF;
		}else{
			if ( FALSE == ImmGetConversionStatus(hIMC, &cStatus, &sStatus) ){
				cStatus = IME_OFF;
			}
		}
		ImmReleaseContext(hTargetWnd, hIMC);
	}
								// IME Ԃωʒm
	if ( NowStatus != cStatus ){
		NowStatus = cStatus | (NowStatus & IME_CAPTIONCHANGE);
		PostMessage(hClockPodWnd, WM_COMMAND,
				TMAKELPARAM(cStatus, IMESTATUSREPORTCMD), (LPARAM)hReportWnd);
	}
}

void IMENotifyCheck(HWND hTargetWnd, WPARAM wParam)
{
	HWND hFocusWnd;

	hFocusWnd = GetFocus();
	if ( hFocusWnd == NULL ) return;
	if ( hFocusWnd != hTargetWnd ) return;
	if ( (wParam == IMN_SETCONVERSIONMODE) ||
		 (wParam == IMN_SETOPENSTATUS) ){
		IMEcheck(hFocusWnd, NULL);
	}
}

LRESULT CALLBACK GetSendMessageResultHookProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	UINT message;
	LRESULT lr;
	HWND hFocusWnd;

	if ( (lParam == 0) || (NowStatus == IME_NOTARGET) ){
		return CallNextHookEx(hOldSendHook, nCode, wParam, lParam);
	}
	if ( hOldSendHook == NULL ){
		if ( hClockPodWnd == NULL ){
			hClockPodWnd = FindWindow(T(AppName), T(AppName));
		}
		if ( hClockPodWnd != NULL ){
			hOldSendHook = (HHOOK)GetWindowLongPtr(hClockPodWnd, GWLP_USERDATA);
		}
		if ( hOldSendHook == NULL ){
			return CallNextHookEx(NULL, nCode, wParam, lParam);
		}
	}
	message = ((CWPRETSTRUCT *)lParam)->message;

	if ( message == WM_IME_NOTIFY ){
		IMENotifyCheck(((CWPRETSTRUCT *)lParam)->hwnd, ((CWPRETSTRUCT *)lParam)->wParam);
		return CallNextHookEx(hOldSendHook, nCode, wParam, lParam);
	}

	if ( (message == WM_IME_SETCONTEXT) && (((CWPRETSTRUCT *)lParam)->wParam != 0) && DataGet ){
		DataGet = 0;
		lr = CallNextHookEx(hOldSendHook, nCode, wParam, lParam);
		NowStatus |= IME_CAPTIONCHANGE;
		IMEcheck(((CWPRETSTRUCT *)lParam)->hwnd, NULL);
		return lr;
	}

	if ( message == WM_SETTEXT ){ // WM_SETTEXT ́AmΏۂ̐e܂߂
		HWND hCheckWnd, hWnd;

		hCheckWnd = ((CWPRETSTRUCT *)lParam)->hwnd;
		hWnd = GetFocus();
		for (;;){
			if ( hWnd == NULL ){
				return CallNextHookEx(hOldSendHook, nCode, wParam, lParam);
			}
			hFocusWnd = hWnd;
			if ( hCheckWnd == hWnd ) break;
			hWnd = GetParent(hWnd);
		}

		lr = CallNextHookEx(hOldSendHook, nCode, wParam, lParam);
		NowStatus = IME_CHECK | IME_CAPTIONCHANGE; // K`FbN
	}else{
		if ( message == WM_KILLFOCUS ) NowStatus = IME_CHECK;
		if ( message != WM_SETFOCUS ){
			return CallNextHookEx(hOldSendHook, nCode, wParam, lParam);
		}
		lr = CallNextHookEx(hOldSendHook, nCode, wParam, lParam);
								// Ώۂ
		hFocusWnd = ((CWPRETSTRUCT *)lParam)->hwnd;
		if ( hFocusWnd == NULL ){
			PostMessage(hClockPodWnd, WM_COMMAND,
					TMAKELPARAM(0, IMESTATUSREPORTCMD - 1), 888);
			hFocusWnd = GetFocus();
		}
	}
	if ( hFocusWnd != NULL ) IMEcheck(hFocusWnd, hFocusWnd);
	return lr;
}

LRESULT CALLBACK GetPostMessageHookProc(int nCode, WPARAM wParam, LPARAM lParam)
{
	UINT message;

	if ( (lParam == 0) || (NowStatus == IME_NOTARGET) ){
		return CallNextHookEx(hOldPostHook, nCode, wParam, lParam);
	}
	if ( hOldPostHook == NULL ){
		if ( hClockPodWnd == NULL ){
			hClockPodWnd = FindWindow(T(AppName), T(AppName));
		}
		if ( hClockPodWnd != NULL ){
			hOldPostHook = (HHOOK)GetWindowLongPtr(hClockPodWnd, 0);
		}
		if ( hOldPostHook == NULL ){
			return CallNextHookEx(NULL, nCode, wParam, lParam);
		}
	}
	message = ((MSG *)lParam)->message;

	if ( message == WM_CLOCKPOD ){	// IME ԂύX
		if ( ((MSG *)lParam)->wParam == IMECHANGESTATUSCMD ){
			HIMC hIMC;

			WPARAM result = 1;

			hIMC = ImmGetContext(((MSG *)lParam)->hwnd);
			if ( hIMC != 0 ){
				if ( ImmSetOpenStatus(hIMC, (BOOL)((MSG *)lParam)->lParam) ){
					result = 0;
				}else{
					result = 2;
				}
				ImmReleaseContext(((MSG *)lParam)->hwnd, hIMC);
			}
			PostMessage(hClockPodWnd, WM_COMMAND,
					TMAKELPARAM(0, IMESTATUSREPORTCMD - 1), result);
		}
		return 0;
	}
	if ( message == WM_IME_NOTIFY ){
		IMENotifyCheck(((MSG *)lParam)->hwnd, ((MSG *)lParam)->wParam);
	}
	return CallNextHookEx(hOldPostHook, nCode, wParam, lParam);
}

/*-----------------------------------------------------------------------------
	HOOK ̓o^^
-----------------------------------------------------------------------------*/
__declspec(dllexport) void WINAPI HookSwitch(BOOL sw)
{
	NowStatus = IME_NOTARGET;
	if ( sw != FALSE ){
		if ( hOldSendHook != NULL ) return;
		hClockPodWnd = FindWindow(T(AppName), T(AppName));
		hOldSendHook = SetWindowsHookEx(WH_CALLWNDPROCRET,
				(HOOKPROC)GetSendMessageResultHookProc, hDLLInst, 0);
		SetWindowLongPtr(hClockPodWnd, GWLP_USERDATA, (LONG_PTR)hOldSendHook);
		hOldPostHook = SetWindowsHookEx(WH_GETMESSAGE,
				(HOOKPROC)GetPostMessageHookProc, hDLLInst, 0);
		SetWindowLongPtr(hClockPodWnd, 0, (LONG_PTR)hOldPostHook);
	}else{
		if ( hOldSendHook == NULL ) return;
		UnhookWindowsHookEx(hOldPostHook);
		UnhookWindowsHookEx(hOldSendHook);
		hOldSendHook = NULL;
	}
}
