/*-----------------------------------------------------------------------------
	ClockPod / 풓												(c)TORO
-----------------------------------------------------------------------------*/
#define STRICT
#include <windows.h>
#include <windowsx.h>
#include "CLOCKPOD.H"

RECT ClkRect;	// NbÑ}EẌʒu(Drag)
POINT ClkPos;	// NbÑ}EẌʒu

#define RRATEPIXS 5
int rrate[RRATEPIXS] = {5, 3, 2, 1, 1};

#define RateScalePix(clr, rate) ((((((clr) & 0xff00ff) * (rate)) & 0xff00ff00) + ((((clr) & 0xff00) * (rate)) & 0xff0000)) >> 8)
#define ModifyPixPtr(x, y) (DWORD *)(MdcBitsPtr + (((y) * MdcBitsSize.cx) + (x)) * sizeof(DWORD) )

xBLENDFUNCTION DefaultBlend = {
	/* BlendOp */ AC_SRC_OVER, /* BlendFlags */ 0,
	/* SourceConstantAlpha */ 255, /* AlphaFormat */ AC_SRC_ALPHA
};
POINT ZeroPoint = {0, 0};

// \xƂɈꎞIɉe\ɂ邽߂̏
DWORD DrawTime = 0; // O̕`掞
int TinyDrawMode; // ꎞIe\ɂ/X_shadow̃obNAbv
int TinyDispMesX = 0; // e\JnƂ DispMesXBe\邽߂Ɏgp

/*-----------------------------------------------------------------------------
	\
-----------------------------------------------------------------------------*/
//------------------------------------- C_AUTO WJ
COLORREF USEFASTCALL UseColor(COLORREF var, COLORREF autovar)
{
	return (var == C_AUTO) ? autovar : var;
}

#ifdef UNICODE
void Z_ExecActionWith1ParamStrings(int ID, LPARAM param1)
{
	TCHAR mbuf[MESLEN];
	WCHAR paramW[MESLEN];

	if ( (*(char *)((char *)param1 + 1) | *(char *)((char *)param1 + 3)) != 0 ){ // Ansi
		AnsiToUnicode((char *)param1, paramW, MESLEN);
		param1 = (LPARAM)paramW;
	}
	wsprintf(mbuf, T("1%s"), (TCHAR *)param1);
	Z_ExecAction(ID, mbuf);
}
#else
	#define Z_ExecActionWith1ParamStrings(ID, param1) Z_ExecActionWith1ParamD(ID, T("1%s"), param1)
#endif

void Z_ExecActionWith1ParamD(int ID, const TCHAR *format, LPARAM param1)
{
	TCHAR mbuf[MESLEN];

	wsprintf(mbuf, format, param1);
	Z_ExecAction(ID, mbuf);
}

void WmDisplayChange(WPARAM wParam, LPARAM lParam)
{
	TCHAR mbuf[MESLEN];

	wsprintf(mbuf, T("1%d\t2%d\t3%d"), LOWORD(lParam), HIWORD(lParam), wParam);
	Z_ExecAction(zDisplayChg, mbuf);
	InitSysParam();
}

void WmLButtonUp(HWND hWnd, LPARAM lParam)
{
	int oldMouseStatus;

	oldMouseStatus = MouseStatus;
	ReleaseCap(hWnd);
	SetForegroundWindow(ohWnd);
	MoveClock(hWnd);
	if ( oldMouseStatus == MS_LCLICK ){
		POINT pos;
		HWND phWnd;

		if ( DPosOff == &DPosOFFtemp ){
			DPosOff = &DPosOFFS[DPOS_NORMAL];
			MoveClock(hWnd);
		}else{
			LPARAMtoPOINT(pos, lParam);
			ClientToScreen(hWnd, &pos);
			phWnd = GetWindowFromPoint(pos);
			if ( phWnd == hWnd ) Z_ExecAction(zLclick, NULL);
		}
	}
	MouseStatus = MS_NORMAL;
}

void WmRButtonUp(HWND hWnd, LPARAM lParam)
{
	int oldMouseStatus;

	oldMouseStatus = MouseStatus;
	ReleaseCap(hWnd);
	if ( oldMouseStatus == MS_TARGET ){
		POINT pos;
		HWND phWnd;

		LPARAMtoPOINT(pos, lParam);
		ClientToScreen(hWnd, &pos);
		phWnd = GetWindowFromPoint(pos);
		if ( phWnd != NULL ) WindowRupt(hWnd, phWnd, &pos);
	}
	if ( oldMouseStatus == MS_RCLICK ){
		MouseStatus = MS_INMENU;
		SetForegroundWindow98(hWnd);
		WindowMenu(hWnd, 0);
	}
	SetForegroundWindow(ohWnd);
	MoveClock(hWnd);
	MouseStatus = MS_NORMAL;
}

void AlphaFix(int showline, int telopline, COLORREF uubg)
{
	BYTE *p;
	DWORD bgc, NewBgc;
	DWORD bgrate, fgrate, fgalpha;

	if ( NoTranspar ){
		bgrate = 250;
	}else{
		bgrate = (X_transpar * 256) / 100; // X_transpar  0`99
	}
#if 0		// ABGR
	bgc = uubg;
	NewBgc = RateScalePix(uubg, bgrate) | (bgrate << 24);
#else		// ARGB
	bgc = ((uubg & 0xff) << 16) | (uubg & 0xff00) | ((uubg & 0xff0000) >> 16);
	NewBgc = ((((uubg & 0x0000ff) * bgrate) & 0x00ff00) << 8) |
			((((uubg & 0x00ff00) * bgrate) & 0xff0000) >> 8) |
			(((uubg & 0xff0000) * bgrate) >> 24) |
			(bgrate << 24);
#endif
	#undef TRPAR

	fgrate = (X_transtxt * 256) / 100;
	fgalpha = ((fgrate - 1) & 0xff) << 24;

	GdiFlush();

	InterlockedIncrement(&UseMdcBitsPtr);

	p = MdcBitsPtr;
	if ( (p == NULL) /*|| IsBadReadPtr(p + MdcBitsSize.cx * MdcBitsSize.cy * 4 - 4, 1)*/ ){
		// ꎞI MdcBitsPtr ̗̈悪ɂȂĂ邽߁Af
		// ŏ̂PubNmۂĂȂƂ
		InterlockedDecrement(&UseMdcBitsPtr);
		return;
	}

	if ( DispMesStock == 0 ){ // Sċ
		int size;

		size = MdcBitsSize.cx * MdcBitsSize.cy;
		for ( ; size ; size-- ){
			DWORD c;

			c = *(DWORD *)p;
			if ( c == bgc ){
				*(DWORD *)p = NewBgc;
			}else{
				*(DWORD *)p = RateScalePix(c, fgrate) + fgalpha;
			}
			p += 4;
		}
	}else{ // ebvsʈ
		int line;

		if ( (showline * FontSize.y) > MdcBitsSize.cy ){
			showline = MdcBitsSize.cy / FontSize.y;
		}
		for ( line = 0 ; line < showline ; line++ ){
			p = MdcBitsPtr + (showline - line - 1) * FontSize.y * MdcBitsSize.cx * sizeof(DWORD);

			if ( line != telopline ){ // ebvsȊO
				int width;

				width = MdcBitsSize.cx * FontSize.y;
				for ( ; width ; width-- ){
					DWORD c;

					c = *(DWORD *)p;
					if ( c == bgc ){
						*(DWORD *)p = NewBgc;
					}else{
						*(DWORD *)p = RateScalePix(c, fgrate) + fgalpha;
					}
					p += sizeof(DWORD);
				}
			}else{ // ebvs
				int x, y;

				for ( y = 0 ; y < FontSize.y ; y++ ){
					for ( x = 0 ; x < MdcBitsSize.cx ; x++ ){
						DWORD c;

						c = *(DWORD *)p;
						if ( c == bgc ){
							*(DWORD *)p = NewBgc;
						}else{
							#define TRATE 16
							if ( (x < TRATE) || (x > (MdcBitsSize.cx - TRATE)) ){
								DWORD f1rate, f2rate;
								f2rate = ((256 * ((x < TRATE) ? x : (MdcBitsSize.cx - x))) / TRATE);
								f1rate = (f2rate * fgrate) >> 8;
								f2rate = ((255 - f2rate) * bgrate) >> 8;
								*(DWORD *)p = RateScalePix(c, f1rate) |
										RateScalePix(NewBgc, f2rate) |
										((f1rate + f2rate) << 24);
							}else{
								*(DWORD *)p = RateScalePix(c, fgrate) + fgalpha;
							}
						}
						p += sizeof(DWORD);
					}
				}
			}
		}
	}

	if ( (MdcBitsSize.cx > RRATEPIXS) && (MdcBitsSize.cy > RRATEPIXS) ){
		int i;

		for ( i = 0 ; i < RRATEPIXS ; i++ ){
			int r, x;

			r = rrate[i];
			for ( x = 0 ; x < r ; x++ ){
				*ModifyPixPtr(x, i) = 0;
				*ModifyPixPtr(MdcBitsSize.cx - x - 1, i) = 0;

				*ModifyPixPtr(x, MdcBitsSize.cy - 1 - i) = 0;
				*ModifyPixPtr(MdcBitsSize.cx - x - 1, MdcBitsSize.cy - 1 - i) = 0;
			}
		}
	}
	InterlockedDecrement(&UseMdcBitsPtr);
}

void PaintMain(HDC hDC, BOOL usebg)
{
	HFONT hOldFont;
	POINT CP;
	COLORS *clrs;
	COLORREF bg, shadowFg;
	COLORREF uubg;

	int drawY, line, telopline = -1, showline;
	int shadowmode, oldbkmode = -1, extwidth = 0;
	BOOL backdraw;

	if ( TinyDispMesX < DispMesX ){ // \̊ȗ`FbN
		TinyDispMesX = 0;
		X_shadow = TinyDrawMode;
		TinyDrawMode = 0;
	}else if ( (X_shadow >= 2) && (DrawTime > 80) && (DispMesX < -WindowSize.cx) ){ // \̊ȗ`FbN
		TinyDispMesX = DispMesX;
		TinyDrawMode = X_shadow;
		X_shadow = 1;
	}
										// \̐ݒ ---------------------
	hOldFont = SelectObject(hDC, hBoxFont);	// tHg
	SetTextAlign(hDC, TA_LEFT | TA_TOP | TA_UPDATECP);	// CP L
										// zF̌
	if ( !DispMesStock || (C_telop.fg == C_telop.bg) ){
		clrs = &C_use;
	}else{
		clrs = &C_telop;
	}
	uubg = bg = UseColor(clrs->bg, C_title.bg);
	SetBkColor(hDC, bg);

	if ( (X_transpar < 100) || X_shadow ){ // wi̐
		oldbkmode = SetBkMode(hDC, TRANSPARENT);
		if ( usebg != FALSE ){ // wihԂ
			HBRUSH hbr;
			RECT box;

			box.left	= 0;
			box.top		= 0;
			box.right	= WindowSize.cx;
			box.bottom	= WindowSize.cy;
			hbr = CreateSolidBrush(NoTranspar ? (bg ^ 1) : bg);
			if ( NoTranspar ) uubg ^= 1;
			FillRect(hDC, &box, hbr);
			DeleteObject(hbr);
		}
		if ( X_shadow >= 1 ){
			shadowFg = UseColor(clrs->fg, C_title.fg);
									// 邳vZA`DȂ獕eɂ
			shadowFg = (GetColorBright(shadowFg) > 0x700) ? C_BLACK : C_WHITE;
		}
	}
	showline = textlines;
	if ( DispMesStock ){	// ebv\̒
		telopline = textlines - X_telopl - 1;			// ebv\s
		if ( X_telopl < 0 ) showline++;					// \s
		if ( X_telopx ) extwidth = X_telopx * FontSize.x; // g
	}

	drawY = 0;
	for ( line = 0 ; line < showline ; line++, drawY += FontSize.y ){
		shadowmode = X_shadow;
		backdraw = usebg;
		for(;;){
			CP.x = 0;
			CP.y = drawY;

			switch ( shadowmode ){
				case 1: // e
					SetTextColor(hDC, shadowFg);
					CP.x = LineWidth;
					CP.y = drawY + LineWidth;
					break;

				case 4: // 2b
					CP.x = -LineWidth;

				case 3: // 2a
					SetTextColor(hDC, shadowFg);
					BeginPath(hDC);
					break;

				case 2: // 1
					BeginPath(hDC);
					// default 

				default: // ʏ
					SetTextColor(hDC, UseColor(clrs->fg, C_title.fg) );
			}

			if ( line == telopline ) CP.x += DispMesX;
			MoveToEx(hDC, CP.x, CP.y, NULL);
			while ( CP.x < WindowSize.cx ){
				int x;
										// ݎ̍](ebv\̂)
				if ( extwidth ){
					if ( (backdraw != FALSE) &&
						 (shadowmode == 0) &&
						 ((CP.x + extwidth) > 0) ){
						HBRUSH	hbr;
						RECT	box;

						box.left	= CP.x;
						box.right	= CP.x + extwidth;
						box.top		= drawY;
						box.bottom	= drawY + FontSize.y;
						hbr = CreateSolidBrush(bg);
						FillRect(hDC, &box, hbr);
						DeleteObject(hbr);
					}
					CP.x += extwidth;
					MoveToEx(hDC, CP.x, CP.y, NULL);
				}
										// ݎ̕\ ---------------------
				x = CP.x;
				TextOut(hDC, 0, 0, timetext[line], timelen[line]);
				GetCurrentPositionEx(hDC, &CP);
				if ( CP.x >= WindowSize.cx ) break;
				if ( CP.x < (x + WindowSize.cx - extwidth) ){

					if ( (backdraw != FALSE) && (shadowmode == 0) ){
						RECT box;

						box.right	= x + WindowSize.cx - extwidth;
						if ( box.right > 0 ){
							HBRUSH hbr;

							box.left	= CP.x;
							box.top		= drawY;
							box.bottom	= drawY + FontSize.y;
							hbr = CreateSolidBrush(bg);
							FillRect(hDC, &box, hbr);
							DeleteObject(hbr);
						}
					}
					CP.x = x + WindowSize.cx - extwidth;
					if ( CP.x >= WindowSize.cx ) break;
					MoveToEx(hDC, CP.x, CP.y, NULL);
				}
										// bZ[W̕\ -------------------
				if ( line == telopline ){
					int i;

					for ( i = 0 ; i < DispMesStock ; i++ ){
						POINT LP;

						TextOut(hDC, 0, 0, DMessage[i].mes, (DWORD)tstrlen(DMessage[i].mes));
						GetCurrentPositionEx(hDC, &LP);
						if ( LP.x <= 0 ){ // bZ[WSĉBꂽ\
										//repeat͍폜Ȃ
							if ( !(DMessage[i].flag & DMES_REPEAT) ){
								DispMesStock--;
								if ( DispMesStock == 0 ){
									LP.x = 0; // ́1 DispMesX = 0 ɂȂ
									ForceDraw = TRUE;
									OldaWndLen = 0;
									MoveToEx(hDC, 0, drawY, NULL);
								}else{
									DispMesX += LP.x - CP.x;
									if ( i < DispMesStock ){
										memmove(&DMessage[i], &DMessage[i+1],
										(DispMesStock - i) * sizeof(DMESSAGE));
									}
								}
								i--;
							}
						}
						CP.x = LP.x;
						if ( CP.x >= WindowSize.cx ) break;
					}
					if ( CP.x <= 0 ) DispMesX = CP.x;		// 1
				}else if ( backdraw != FALSE ){		// 󔒂𖄂߂
					HBRUSH	hbr;
					RECT	box;

					if ( shadowmode != 0 ) break; // e`掞͕`sv
					backdraw = FALSE;
					box.left	= CP.x;
					box.right	= WindowSize.cx;
					box.top		= drawY;
					box.bottom	= drawY + FontSize.y;
					hbr = CreateSolidBrush(bg);
					FillRect(hDC, &box, hbr);
					DeleteObject(hbr);
					break;
				}
			}
			if ( shadowmode == 0 ) break;
			if ( shadowmode > 1 ){ // `
				HPEN holdpen;
				HBRUSH holdbr;

				EndPath(hDC);

				if ( shadowmode == 2 ){ // ƕ𓯎`
					holdpen = SelectObject(hDC, CreatePen(PS_SOLID, LineWidth, shadowFg));
					holdbr = SelectObject(hDC, CreateSolidBrush( UseColor(clrs->fg, C_title.fg) ));
					StrokeAndFillPath(hDC);
					DeleteObject(SelectObject(hDC, holdbr));
					DeleteObject(SelectObject(hDC, holdpen));
					break;
				}else{ // êݕ`
					holdpen = SelectObject(hDC, CreatePen(PS_SOLID, (5 * FontDPI) / 96, shadowFg));
					StrokePath(hDC);
					DeleteObject(SelectObject(hDC, holdpen));
				}
			}
			shadowmode = 0; // eE̕`悪ÎŖ{̂`
		}
	}
	if ( oldbkmode != -1 ) SetBkMode(hDC, oldbkmode);
											// n -------------------------
	SetTextAlign(hDC, TA_LEFT | TA_TOP | TA_NOUPDATECP);	// CP 𖳌
	SelectObject(hDC, hOldFont);	// tHg

	if ( TransparMode == TM_DETAIL ) AlphaFix(showline, telopline, uubg);
}

void Paint(HWND hWnd)
{
	PAINTSTRUCT ps;

	BeginPaint(hWnd, (LPPAINTSTRUCT)&ps);
	if ( hMdc == NULL ){
		PaintMain(ps.hdc, TRUE);
	}else{
		if ( TransparMode != TM_DETAIL ){
			BitBlt(ps.hdc, 0, 0, WindowSize.cx, WindowSize.cy, hMdc, 0, 0, SRCCOPY);
		}else{
			HDC hScreenDC;
			POINT wndPos;
			RECT rc;

			hScreenDC = GetDC(NULL);

			GetWindowRect(hWnd, &rc);
			wndPos.x = rc.left;
			wndPos.y = rc.top;

			DUpdateLayeredWindow(hWnd, hScreenDC, &wndPos, &WindowSize, hMdc, &ZeroPoint, 0, &DefaultBlend, ULW_ALPHA);
			ReleaseDC(NULL, hScreenDC);
		}
	}
	EndPaint(hWnd, (LPPAINTSTRUCT)&ps);
}

void DrawWindow(HWND hWnd)
{
	BOOL usebg = TRUE;
	DWORD DrawStartTime = GetTickCount();

	if ( (X_transpar < 100) && (DSetLayeredWindowAttributes == NULL) ){
		if ( !DispMesStock || (C_telop.fg == C_telop.bg) ){
			HDC hdc;

			usebg = FALSE;
			hdc = GetDC(hWnd);
			SetPolyFillMode(hdc, WINDING);
			BeginPath(hdc);
			PaintMain(hdc, FALSE);
			EndPath(hdc);
			SetWindowRgn(hWnd, PathToRegion(hdc), TRUE);
			ReleaseDC(hWnd, hdc);
		}else{
			SetWindowRgn(hWnd, NULL, TRUE);
		}
	}
	InvalidateRect(hWnd, NULL, FALSE);
	if ( hMdc != NULL ) PaintMain(hMdc, usebg);
	DrawTime = GetTickCount() - DrawStartTime;
	if ( DrawTime >= 0x80000000 ) DrawTime = 0 - DrawTime;
}

void SetIMEsetting(HWND hWnd, DWORD state)
{
	HWND hParentWnd, hTempWnd;
	DWORD_PTR dummy;
	ACOFF offset;

	IMEstat = state;
	IMEwndCapLen = aWndLen;
	NowIMEwnd = hWnd;
	if ( state == IME_DIABLE ){
		ChangeIMEwnd = HWND_BROADCAST;
		return; // IMEgȂ̂ŁAłȂ
	}

//	hFocusWnd = hWnd;
	hParentWnd = hWnd;

	for(;;){
		if ( GetWindowLong(hParentWnd, GWL_STYLE) & WS_SYSMENU ) break;
		hTempWnd = GetParent(hParentWnd);
		if ( (hTempWnd == NULL)/* || !IsWindowVisible(hTempWnd)*/ ) break;
		hParentWnd = hTempWnd;
	}
	SendMessageTimeout(hParentWnd, WM_GETTEXT, TSIZEOF(ParentTitle), (LPARAM)ParentTitle, SMTO_ABORTIFHUNG | SMTO_BLOCK, 300, &dummy);

	FocusClass[0] = '\0';
	GetClassName(hWnd, FocusClass, TSIZEOF(FocusClass));
	offset = AC_ime;
	if ( offset == 0 ){
		ChangeIMEwnd = HWND_BROADCAST;
		return; // ݒ薳
	}
	for (;;){
		AC_IMECHANGE *ic;
		TCHAR *str;

		ic = (AC_IMECHANGE *)(cfgac.bottom + offset);
		for (;;){
			// caption `FbN
			str = GetCfgStr(ic->caption);
			if ( *str && (tstrstr(ParentTitle, str) == NULL) ) break;

			// class `FbN
			str = GetCfgStr(ic->classname);
			if ( *str && tstrcmp(FocusClass, str) ) break;
/*
			{
				char ms[0x1000];
				wsprintf(ms,"SetIMEsetting:%x->%x %s %s", state, ic->mode, ParentTitle, FocusClass);
					LogWrite(999, ms);
			}
*/
			// `FbNʂ̂IMEύX
			switch( ic->mode ){
				case IME_CHANGE_ON:
					if ( (state == IME_OFF) || !(state & IME_CMODE_FULLSHAPE)){
//						LogWrite(999,"SetIMEsetting->on");
						PostMessage(hWnd, WM_CLOCKPOD, IMECHANGESTATUSCMD, 1);
						ChangeIMEmode = 1;
						break;
					}
					ChangeIMEwnd = HWND_BROADCAST;
					return;

				case IME_CHANGE_OFF:
					if ( (state != IME_OFF) && (state & IME_CMODE_FULLSHAPE) ){
//						LogWrite(999,"SetIMEsetting->off");
						PostMessage(hWnd, WM_CLOCKPOD, IMECHANGESTATUSCMD, 0);
						ChangeIMEmode = 0;
						break;
					}
//					break;
				//default

				default:
//				case IME_CHANGE_ASIS: // ύXȂ
					ChangeIMEwnd = HWND_BROADCAST;
					return;
			}
			ChangeIMEwnd = hWnd;
			ChangeIMEtick = GetTickCount() + 100;
			ChangeIMElasttick = ChangeIMEtick + 3000 - 100;
			return;
		}
		if ( ic->next == 0 ) break;
		offset = ic->next;
	}
}

void WmMouseMove(HWND hWnd)
{
	if ( MouseStatus != MS_NORMAL ){
		POINT nPos;

		GetCursorPos(&nPos);
										// hbOJn ----------
		if ( PtInRect(&ClkRect, nPos) == FALSE ){
			if ( MouseStatus == MS_RCLICK ){	// EhbO(|Cg)
				MouseStatus = MS_TARGET;
				SetForegroundWindow(hWnd);
				SetDefaultCursor(hWnd, IDC_UPARROW);
				hPointedWnd = NULL;
			}
			if ( MouseStatus == MS_LCLICK ){	// hbO(ړ)
				if ( !MoveMode ){
					SetDefaultCursor(hWnd, IDC_SIZEALL);
					if ( DPosOff != &DPosOFFtemp ){
						DPosOFFtemp.x = aRect.right - WindowSize.cx + DPosOff->x;
						DPosOFFtemp.y = aRect.top - DPosOff->y;
						DPosOff = &DPosOFFtemp;
					}
				}
				MouseStatus = MS_DRAG;
			}
		}
		if ( MouseStatus == MS_DRAG ){	// ړ
			if ( LappedTaskBar ){		// ^XNo[ɏdȂĂ鎞
				DPosOFFS[DPOS_ONTASKBAR].x += nPos.x - ClkPos.x;
				DPosOFFS[DPOS_ONTASKBAR].y += nPos.y - ClkPos.y;
			}else{
				DPosOff->x += nPos.x - ClkPos.x;
				DPosOff->y += nPos.y - ClkPos.y;
			}
			MoveClock(hWnd);
			ClkPos.x = nPos.x;
			ClkPos.y = nPos.y;
		}
		if ( MouseStatus == MS_TARGET ){	// |Cg
			HWND nhWnd;

			nhWnd = GetWindowFromPoint(nPos);
			if ( nhWnd != NULL ){
				if ( nhWnd != hPointedWnd ){
					DrawFocusWindow(nhWnd, TRUE);
					hPointedWnd = nhWnd;
				}
			}
		}
	}else{
		if ( (NearPointer == FALSE) && X_dodge ){
			NearPointer = TRUE;
			MoveClock(hWnd);
		}
		 if ( X_transpar == 0 ){ // ̎Awi\`FbN
			if ( NoTranspar == FALSE ){
				NoTranspar = TRUE;
				DrawWindow(hWnd);
			}
		}
	}
}

/*-----------------------------------------------------------------------------
	bZ[W
-----------------------------------------------------------------------------*/
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message){
//====================================== ebvp
		case WM_DEVICECHANGE:
			DevChange(wParam, lParam);
			goto DefWindow;
		case WM_DEVMODECHANGE:
			Z_ExecActionWith1ParamStrings(zDevmodeChg, lParam);
			InitSysParam();
			break;
		case WM_DISPLAYCHANGE:
			WmDisplayChange(wParam, lParam);
			break;
		case WM_RASDIALEVENT:
			SetMessage(zNoID, T("RAS message"), DMES_LOGTELOP, NULL);
			goto DefWindow;
		case WM_POWER: {
			TCHAR *p = T("1Unknown");

			switch (wParam){
				case PWR_CRITICALRESUME:
					p = T("1CRITICALRESUME");
					break;
				case PWR_SUSPENDREQUEST:
					p = T("1SUSPENDREQUEST");
					break;
				case PWR_SUSPENDRESUME:
					p = T("1SUSPENDRESUME");
					break;
			}
			Z_ExecAction(zPower, p);
			goto DefWindow;
		}
		case WM_POWERBROADCAST:
			BatteryCheckMain();
			goto DefWindow;
		case WM_SETTINGCHANGE:
//		case WM_WININICHANGE:	// WM_SETTINGCHANGE ̋
			if ( lParam == 0 ){
				Z_ExecAction(zSettingChg, T("1All"));
			}else if ( Isalnum(*(LPCSTR)lParam) ){
				Z_ExecActionWith1ParamStrings(zSettingChg, lParam);
			}else{
				Z_ExecAction(zSettingChg, T("1Setting"));
			}
			InitSysParam();
			break;

#ifndef WM_DPICHANGED
#define WM_DPICHANGED 0x02E0
#endif
		case WM_DPICHANGED:
			InitSysParam();
			break;

		case WM_SPOOLERSTATUS:
			if ( LOWORD(lParam) ){
				Z_ExecActionWith1ParamD(zPrinting, T("1%d"), LOWORD(lParam));
			}else{
				Z_ExecAction(zPrintDone, NULL);
			}
			break;
		case WM_FONTCHANGE:
			Z_ExecAction(zFontChange, NULL);
			break;
		case WM_SYSCOLORCHANGE:
			Z_ExecAction(zSysColor, NULL);
			break;
		case WM_TIMECHANGE:
			Z_ExecAction(zTimeChange, NULL);
			GetLocalTime(&ltime);
			break;
		case WM_COMPACTING:	// wParam:gpCPU% 50%=0x8000
			Z_ExecActionWith1ParamD(zCompacting, T("1%d"), ((int)wParam * 50) / 0x8000);
			break;
//====================================== }EX
							// }EẌړ(w:, lH:Y, lL:X)---------
		case WM_MOUSEMOVE:
			WmMouseMove(hWnd);
			break;
							// }EX̍NbN(w:, lH:Y, lL:X)--------
		case WM_LBUTTONDOWN:
			if ( MouseStatus != MS_NORMAL){
				ReleaseCap(hWnd);
				MouseStatus = MS_NORMAL;
				break;
			}
			ohWnd = ahWnd;
//			WM_RBUTTONDOWN ֑c
							// }EX̉ENbN(w:, lH:Y, lL:X)--------
		case WM_RBUTTONDOWN:
			if ( MouseStatus != MS_NORMAL ){
				ReleaseCap(hWnd);
				MouseStatus = MS_NORMAL;
				break;
			}else{
				int x = GetSystemMetrics(SM_CXDOUBLECLK);
				int y = GetSystemMetrics(SM_CYDOUBLECLK);

				ohWnd = ahWnd;
				LPARAMtoPOINT(ClkPos, lParam);
				ClientToScreen(hWnd, &ClkPos);
				ClkRect.left	= ClkPos.x - x;
				ClkRect.right	= ClkPos.x + x;
				ClkRect.top		= ClkPos.y - y;
				ClkRect.bottom	= ClkPos.y + y;

				SetCapture(hWnd);
				MouseStatus = (wParam & MK_RBUTTON) ? MS_RCLICK : MS_LCLICK;
				break;
			}
		case WM_MBUTTONDOWN:
			if ( MouseStatus != MS_NORMAL ){
				ReleaseCap(hWnd);
				MouseStatus = MS_NORMAL;
				break;
			}
			break;
							// }EX̒NbN(w:, lH:Y, lL:X)--------
		case WM_MBUTTONUP: {
			int oldMouseStatus;

			oldMouseStatus = MouseStatus;
			ReleaseCap(hWnd);
			SetForegroundWindow(ohWnd);
			if ( oldMouseStatus == MS_NORMAL ) Z_ExecAction(zMclick, NULL);
			break;
		}
							// }EX̍NbN(w:, lH:Y, lL:X)--------
		case WM_LBUTTONUP:
			WmLButtonUp(hWnd, lParam);
			break;
							// }EX̉ENbN(w:, lH:Y, lL:X)--------
		case WM_RBUTTONUP:
			WmRButtonUp(hWnd, lParam);
			break;

		case WM_CAPTURECHANGED:
			MouseStatus = MS_NORMAL;
			break;

		case WM_SYSCOMMAND:
			if ( (wParam & 0xfff0) == SC_HOTKEY ){
				MouseStatus = MS_INMENU;
				WindowMenu(hWnd, 1);
				MouseStatus = MS_NORMAL;
				break;
			}else{
				goto DefWindow;
			}

		case WM_COMMAND:
/*
			if ( HIWORD(wParam) == (IMESTATUSREPORTCMD -1)){

				{
					char ms[100];
					wsprintf(ms,"result:%d", lParam);
					LogWrite(999, ms);
				}
					break;
			}
*/
			if ( HIWORD(wParam) == IMESTATUSREPORTCMD ){
/*
				{
					char ms[100];
					wsprintf(ms,"IMESTATUSREPORTCMD:%08x,%x", lParam, LOWORD(wParam));
					LogWrite(999, ms);
				}
*/
				if ( (HWND)lParam != NULL ){
					SetIMEsetting((HWND)lParam, LOWORD(wParam));
				}
				GetIMEinfo(LOWORD(wParam));
				break;
			}
										// Win32s ̂Ƃ̂ݎg
			MenuCmd = LOWORD(wParam);
			break;
							//
		case WM_HOTKEY:
			if ( wParam == KEYID_L ){
				if ( DPosOff == &DPosOFFtemp ){
					DPosOff = &DPosOFFS[DPOS_NORMAL];
					MoveClock(hWnd);
					break;
				}
				Z_ExecAction(zLclick, NULL);
				break;
			}
			if ( wParam == KEYID_M ){
				Z_ExecAction(zMclick, NULL);
				break;
			}
			if ( wParam == KEYID_R ){
				ohWnd = ahWnd;
				MouseStatus = MS_INMENU;
				SetForegroundWindow98(hWnd);
				WindowMenu(hWnd, 1);
				SetForegroundWindow(ohWnd);
				MouseStatus = MS_NORMAL;
				MoveClock(hWnd);
				break;
			}
			break;
							// ̍ĕ`(w:gp, l:gp) ------------------
		case WM_PAINT:
			Paint(hWnd);
			break;
							// Iv(w:gp, l:gp) --------------------
//		case WM_CLOSE:	//defaultDestroyWindowĂяo
//			DestroyWindow(hWnd);// ̔j(WM_DESTROY)
//			break;
							// ̔j,I(w:gp, l:gp) -----------
		case WM_DESTROY:
			Close();		// KvȌ㏈s
			if ( X_IME >= 2 ){
				UseCPodDLL(0);
				PostMessage(HWND_BROADCAST, WM_NULL, 0, 0); // Hook .DLL Sĉ
			}
			PostQuitMessage(EXIT_SUCCESS);	// ŏI
			break;
							// Iv(w:gp, l:gp) ----------------
// w=0 logoff   w != 0 [Uɂ邱̃\tg̋I
//		case WM_QUERYENDSESSION:
//			return (long)TRUE;	// TRUE ȂΏI, FALSE ȂI̋
							// I̕ -----------------------------
		case WM_ENDSESSION:
			if (wParam){	// TRUE:ZbV̏I(WM_DESTROY ͒ʒmȂ)
				Close();		// KvȌ㏈s
			}
			break;

		case WM_CP_EXECACTION: // Actions(Mail Thread ̒ʐM)
			ExecAction(((CPESTRUCT *)lParam)->ac, ((CPESTRUCT *)lParam)->id,
						((CPESTRUCT *)lParam)->param);
			break;

		case WM_TRAY_T:	// Task Tray ̒ʒmM
			switch (lParam){
				case WM_LBUTTONUP:
				case WM_RBUTTONDBLCLK:
					if ( BallonText[0] != '\0' ){
						TrayMessage(hWnd, NIM_MODIFY, 0, NULL, BallonText);
					}
					break;

				case NIN_BALLOONUSERCLICK:
					TrayMessage(hWnd, NIM_DELETE, 0, NULL, NULL);
					BallonText[0] = '\0';
					break;
			}
			break;

							// mȂbZ[W -----------------------------
		default:
			if ( message == WM_TASKBARCREATE ){
				Z_ExecAction(zNewTaskbar, NULL);
				InitSysParam();
				break;
			}
			goto DefWindow;
	}
	return 0;

DefWindow:
	return DefWindowProc(hWnd, message, wParam, lParam);
}
