/*-----------------------------------------------------------------------------
	ClockPod / ̑
-----------------------------------------------------------------------------*/
#define STRICT
#include <windows.h>
#include <windowsx.h>
#include "CLOCKPOD.H"

struct {
	SIZE BoxSize;	// ANeBuEBhE̘g̑傫
	int Style;		// ANeBuEBhẼEBhEX^C
} ActiveWnd;

struct {
	// Window \Ƃ̃X^C
	DWORD Style;
	DWORD PopFindTick;
	HWND hPopFindWnd;
} MoveClockInfo = {
	/* Style       */ SWP_NOACTIVATE | SWP_NOCOPYBITS,
	/* PopFindTick */ 0,
	/* hPopFindWnd */ NULL,
};

typedef enum xMONITOR_DPI_TYPE {
	xMDT_EFFECTIVE_DPI = 0,
	xMDT_ANGULAR_DPI = 1,
	xMDT_RAW_DPI = 2,
	xMDT_DEFAULT = xMDT_EFFECTIVE_DPI
} MONITOR_DPI_TYPE;

HMODULE hShcore = NULL;
DefineWinAPI(BOOL, GetDpiForMonitor, (HMONITOR hMonitor, enum xMONITOR_DPI_TYPE dpiType, UINT *dpiX, UINT *dpiY)) = NULL;

//====================================================================== ̑
void SetTransparent(void)
{
	if ( DSetLayeredWindowAttributes == NULL ){
		if ( X_transpar == 100 ){
			SetWindowRgn(hMainWnd, NULL, FALSE);
			TransparMode = TM_OFF;
		}else{
			TransparMode = TM_REGION;
		}
		return;
	}

	if ( X_transpar >= 100 ){
		SetWindowLong(hMainWnd, GWL_EXSTYLE,
				GetWindowLong(hMainWnd, GWL_EXSTYLE) & ~WS_EX_LAYERED);
		TransparMode = TM_OFF;
	}else{
		SetWindowLong(hMainWnd, GWL_EXSTYLE,
				GetWindowLong(hMainWnd, GWL_EXSTYLE) | WS_EX_LAYERED);

		if ( X_transtxt != 0 ){
			TransparMode = TM_DETAIL;
		}else{
			TransparMode = TM_ALL;

			if ( X_transpar != 0 ){
				DSetLayeredWindowAttributes(hMainWnd, 0,
						(BYTE)(DWORD)((255 * X_transpar) / 100), LWA_ALPHA);
			}else{
				DSetLayeredWindowAttributes(hMainWnd, C_title.bg, 0, LWA_COLORKEY);
			}
		}
	}
}

COLORREF USEFASTCALL GlassFix(COLORREF color)
{
	if ( (OSver.dwMajorVersion != 6) || (OSver.dwMinorVersion > 1) ){
		return color;
	}
	color = color + 0x50;
	if ( color >= 0x100 ) color = 0xff;
	return color;
}

//------------------------------------- VXe擾
void InitSysParam(void)
{
	HDC hDC;
	TEXTMETRIC tm;
	HFONT hOldFont;	//ꎞۑp

	if ( hDWMAPI == NULL ){
		hDWMAPI = LoadLibraryA("dwmapi.dll");
	}
	if ( hDWMAPI != NULL ){
		GETDLLPROC(hDWMAPI, DwmGetColorizationColor);
		GETDLLPROC(hDWMAPI, DwmIsCompositionEnabled);
	}
											// F擾 -------------------
	C_title.fg = GetSysColor(COLOR_CAPTIONTEXT);		// F

	C_title.bg = GetSysColor(COLOR_GRADIENTACTIVECAPTION);	// wiF 5.0ȍ~
	if ( C_title.bg == 0 ){
		C_title.bg = GetSysColor(COLOR_ACTIVECAPTION);		// wiF 4.x
	}

	if ( DDwmGetColorizationColor != NULL ){
		BOOL tmp = FALSE;

		DDwmIsCompositionEnabled(&tmp);
		if ( tmp && SUCCEEDED(DDwmGetColorizationColor(&C_title.bg, &tmp)) ){
			C_title.bg = (GlassFix(C_title.bg & 0xff) << 16) | (GlassFix((C_title.bg & 0xff00) >> 8) << 8) | GlassFix((C_title.bg & 0xff0000) >> 16);
			C_title.fg = (GetColorBright(C_title.bg) > 0x500) ? C_BLACK : C_WHITE;
		}
	}

	hDC = GetDC(hMainWnd);
											//  -------------
	if ( hMdc != NULL ){
		DeleteObject(SelectObject(hMdc, hOldMBMP));
		DeleteDC(hMdc);
		hMdc = NULL;
	}
	if ( (X_telopq && X_shadow) || (TransparMode == TM_DETAIL) ){
		hMdc = CreateCompatibleDC(hDC);
		hOldMBMP = SelectObject(hMdc, CreateCompatibleBitmap(hDC, 1, 1));
	}
											// tHg擾 -------------
	if ( hBoxFont != NULL ) DeleteObject(hBoxFont);

	if ( lBoxFont.dpi == 0 ){
		lBoxFont.dpi = GetDeviceCaps(hDC, LOGPIXELSX);
	}
	FontDPI = GetMonitorDPI(hMainWnd);
	LineWidth = FontDPI / lBoxFont.dpi;
	if ( LineWidth < 0 ) LineWidth = 1;
	lBoxFont.font.lfHeight = (FontHeight * FontDPI) / lBoxFont.dpi;
	if ( X_transpar == 0 ){ // S߂̎̓A`GCAX𖳌ɂ
		BYTE defaultQuality;

		defaultQuality = lBoxFont.font.lfQuality;
		lBoxFont.font.lfQuality = NONANTIALIASED_QUALITY;
		hBoxFont	= CreateFontIndirect(&lBoxFont.font);
		lBoxFont.font.lfQuality = defaultQuality;
	}else{
		hBoxFont	= CreateFontIndirect(&lBoxFont.font);
	}
	hOldFont	= SelectObject(hDC, hBoxFont);
	GetTextMetrics(hDC, &tm);
	FontSize.x	= tm.tmAveCharWidth;
	FontSize.y	= tm.tmHeight + tm.tmExternalLeading;
	PFont		= tm.tmPitchAndFamily & TMPF_FIXED_PITCH;
	SelectObject(hDC, hOldFont);
	ReleaseDC(hMainWnd, hDC);
											// EBhE擾 -----------
	bhWnd = FindWindow(T(TRAYNAME), NULL);
	if ( OSver.dwMajorVersion >= 4 ){
		dhWnd = FindWindow(T("Progman"), NULL);
		if (dhWnd == NULL) dhWnd = GetDesktopWindow();
	}else{		// Win32s
		dhWnd = GetDesktopWindow();
	}
											// }`j^̔ -------------
	if ( GetSystemMetrics(SM_CMONITORS) > 1 ){	// }`j^
		HMODULE hUser32;

		hUser32 = GetModuleHandleA("USER32.DLL");
		GETDLLPROC(hUser32, MonitorFromWindow);
		GETDLLPROCT(hUser32, GetMonitorInfo);
	}else{										// VOj^
		DMonitorFromWindow = NULL;
		sRect.left		= 0;
		sRect.top		= 0;
		sRect.right 	= GetSystemMetrics(SM_CXSCREEN);
		sRect.bottom	= GetSystemMetrics(SM_CYSCREEN);
	}

	{										// LvV̒擾
		LOGFONT tmplogfont[2];

		CaptionFontX = 8;	// Ƃ肠̒l
		if ( GetRegString(HKEY_CURRENT_USER,
			  T("Control Panel\\Desktop\\WindowMetrics"), T("CaptionFont"),
			  (TCHAR *)&tmplogfont, sizeof tmplogfont) != FALSE ){
			HFONT hFont;

			hFont = CreateFontIndirect(&tmplogfont[0]);
			if ( hFont != NULL ){
				hDC			= GetDC(hMainWnd);
				hOldFont	= SelectObject(hDC, hFont);
				GetTextMetrics(hDC, &tm);
				SelectObject(hDC, hOldFont);
				ReleaseDC(hMainWnd, hDC);
				DeleteObject(hFont);
								 				// Kɕ(^^;
				CaptionFontX = ( tm.tmAveCharWidth * 9 +
								 tm.tmMaxCharWidth * 7) / 16;
			}
		}
			// LvVACŔ̕ALvV̍ƓȂ̂ŁA
			// ̒lőւB
		CaptionIconX = GetSystemMetrics(SM_CYCAPTION);
	}
	ResetTime();
}
//------------------------------------- ClockPod Mail ̉
void PodMail(TCHAR *Status, DWORD size)
{
	TCHAR pcname[200], rasname[200];

	Status[size + 1] = 0;
										// ʃbZ[W ---------------------
	if ( (Status[1] != '<') || (Status[tstrlen(Status) - 1] != '>') ){
		Z_ExecAction(zCpodSlot, Status);
		return;
	}
	Status++;
										// "<Disconnect:>" ؒfʒm -----------
	if ( !memcmp(Status, T("<Disconnect:"), TSTROFF(12)) ){
		if (Rasnames(Status + 12, pcname, rasname)){
			DelConnection(pcname, rasname);
		}
		return;
	}
										// "<Connect:>" ڑʒm --------------
	if ( !memcmp(Status, T("<Connect:"), TSTROFF(9)) ){
		if (Rasnames(Status + 9, pcname, rasname)){
			AddConnection(pcname, rasname);
		}
		return;
	}
										// "<Connections:>" ڑԒʒm˗ --
	if ( !memcmp(Status, T("<Connections>"), TSTROFF(13)) ){
		int i;
		TCHAR buf[MESLEN];

		if (X_ras > 1) for ( i = 0 ; i < MAXRAS ; i++ ){
			if ( ConnectionList[i].rasname[0] ){
				wsprintf(buf, T("<Connect:%s/%s>"),
						ConnectionList[i].rasname, ConnectionList[i].pcname);
				SendPodSlot(T("*"), buf);
			}
		}
		return;
	}
										// "<DoDisConnect:>" ؒf˗ ---------
	if ( !memcmp(Status, T("<DoDisconnect:"), TSTROFF(14)) ){
		if (X_rascut && hRASAPI32 && Rasnames(Status + 14, pcname, rasname)){
			if ( !tstrcmp(pcname, PCname) ){
				RASCONN	Rasconn[MAXRAS];
				DWORD vsize, connections;

				vsize = sizeof(Rasconn);
				Rasconn[0].dwSize = sizeof(RASCONN);

				if ( DRasEnumConnections(
						(LPRASCONN)&Rasconn, &vsize, &connections) ){
					Z_ExecAction(zError, T("1RAS"));
				}else{
					DWORD i;

					for ( i = 0 ; i < connections ; i++ ){
						if (!tstrcmp(rasname, Rasconn[i].szEntryName)){
							if (DRasHangUp(Rasconn[i].hrasconn)){
								Z_ExecAction(zError, T("1RASHANGUP"));
							}
							break;
						}
					}
				}
			}
		}
		return;
	}
}
/*-------------------------------------
 Win32 ł TPM_RETURNCMD Ή TrackPopupMenu
 AMENU ID=1(TRUE) ̍ڂ܂ HMENU ͎gps
-------------------------------------*/
int TrackPopupMenuSx(HMENU popup, int x, int y, HWND hWnd)
{
	int index;

	// WS_EX_NOACTIVATE ŃANeBuɂȂĂȂ炱ŃANeBuɂ
	SetForegroundWindow(hWnd);

	index = TrackPopupMenu(popup, TPM_TDEFAULT, x, y, 0, hWnd, NULL);

	if ( index == TRUE ){ // TRUE(1) ȂTPM_RETUENCMD ĂȂqueœ
		MSG msg;

		while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)){
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
		index = MenuCmd;
	}
	return index;
}
//------------------------------------- GetWindowFromPoint ̕⏕[`
struct GETCHILD {
	RECT box;
	HWND hWnd;
	POINT pos;
};
BOOL CALLBACK GetWindowFromPointProc(HWND hWnd, LPARAM gc)
{
	RECT box;

	if ( !IsWindowVisible(hWnd) ) return TRUE;
	GetWindowRect(hWnd, &box);
	if (PtInRect(&box, ((struct GETCHILD *)gc)->pos) &&
			(((struct GETCHILD *)gc)->box.left   <= box.left  ) &&
			(((struct GETCHILD *)gc)->box.top    <= box.top   ) &&
			(((struct GETCHILD *)gc)->box.right  >= box.right ) &&
			(((struct GETCHILD *)gc)->box.bottom >= box.bottom) ){
		((struct GETCHILD *)gc)->hWnd = hWnd;
	}
	return TRUE;
}
//------------------------------------- wW̃EBhEɒo
HWND GetWindowFromPoint(POINT sPos)
{
	struct GETCHILD gc;
	HWND hWnd;
										// ܂Ae
	gc.hWnd = WindowFromPoint(sPos);
	if ( gc.hWnd == NULL ) return gc.hWnd;
							// qABĂ̂T߁A
							// ChildWindowFromPoint ĎgȂ
	GetWindowRect(gc.hWnd, &gc.box);
	gc.pos = sPos;
	if ( (GetWindowLong(gc.hWnd, GWL_STYLE) & WS_CHILD) ){
		hWnd = GetParent(gc.hWnd);
		if ( hWnd != NULL ) gc.hWnd = hWnd;
	}
	EnumChildWindows(gc.hWnd, GetWindowFromPointProc, (LPARAM)&gc);
	return gc.hWnd;
}
//------------------------------------- Z_ p ExecAction
void USEFASTCALL Z_ExecAction(int ID, const TCHAR *param)
{
	ExecAction((ACTIONS *)(cfgac.bottom + Z_[ID]), ID, param);
	return;
}
//------------------------------------- }EX̃Lv`[
void ReleaseCap(HWND hWnd)
{
	ReleaseCapture();
	if ( MoveMode == 0 ) SetDefaultCursor(hWnd, IDC_ARROW);
	DrawFocusWindow(NULL, FALSE);
}
//------------------------------------- g̋\
const TCHAR FrameClassName[] = T("CpodFrame");

void DrawFocusWindow(HWND hWnd, BOOL show)
{
	RECT box;
	HRGN hRgn1, hRgn2, hRgn;

	if ( show == FALSE ){ // 
		if ( hWndFocus != NULL ){
			DestroyWindow(hWndFocus);
			hWndFocus = NULL;
		}
		return;
	}
	// \
#ifndef _WIN64
	if ( OSver.dwMajorVersion < 4 ){ // Win3.x̓[WgȂ
		HDC hDC;
		HWND DhWnd = GetDesktopWindow();

		hDC = GetWindowDC(DhWnd);
		if ( hWnd != hPointedWnd ){
			GetWindowRect(hPointedWnd, &box);
			DrawFocusRect(hDC, &box);
		}
		GetWindowRect(hWnd, &box);
		DrawFocusRect(hDC, &box);
		ReleaseDC(DhWnd, hDC);
		return;
	}
#endif
	if ( hWndFocus == NULL ){
		WNDCLASS FrameClass;
#ifndef _WIN64
		DWORD StyleEx = WS_EX_TOPMOST | WS_EX_TOOLWINDOW;

		if ( OSver.dwMajorVersion >= 5 ) StyleEx |= WS_EX_NOACTIVATE;
#else
		#define StyleEx WS_EX_TOPMOST | WS_EX_TOOLWINDOW | WS_EX_NOACTIVATE
#endif
		FrameClass.style		= 0;
		FrameClass.lpfnWndProc	= DefWindowProc;
		FrameClass.cbClsExtra	= 0;
		FrameClass.cbWndExtra	= 0;
		FrameClass.hInstance	= hMainInst;
		FrameClass.hIcon		= NULL;
		FrameClass.hCursor		= NULL;
		FrameClass.hbrBackground	= (HBRUSH)(COLOR_HIGHLIGHT + 1);
		FrameClass.lpszMenuName	= NULL;
		FrameClass.lpszClassName	= FrameClassName;
		RegisterClass(&FrameClass);

		hWndFocus = CreateWindowEx(StyleEx, FrameClassName, NilStr,
				WS_VISIBLE | WS_POPUP | WS_BORDER, 0, 0, 0, 0, NULL, NULL,
				hMainInst, NULL);
		ShowWindow(hWndFocus, SW_HIDE);
	}
	GetWindowRect(hWnd, &box);
	box.right -= box.left;
	box.bottom -= box.top;

	hRgn = CreateRectRgn(0, 0, 1, 1);
	hRgn1 = CreateRectRgn(0, 0, box.right, box.bottom);
	hRgn2 = CreateRectRgn(3, 3, box.right - 3, box.bottom - 3);
	CombineRgn(hRgn, hRgn1, hRgn2, RGN_DIFF);
	DeleteObject(hRgn1);
	DeleteObject(hRgn2);
	SetWindowRgn(hWndFocus, hRgn, TRUE);
	SetWindowPos(hWndFocus, HWND_TOP, box.left, box.top,
			box.right, box.bottom, SWP_NOACTIVATE | SWP_SHOWWINDOW);
}
/*-----------------------------------------------------------------------------
	̃EBhEɐ؂芷
-----------------------------------------------------------------------------*/
void SetNextWindow(HWND hWnd)
{
	HWND fhWnd, nhWnd;

	nhWnd = fhWnd = GetWindow(hWnd, GW_HWNDNEXT);
	for(;;){
		if ( (nhWnd != dhWnd) && (nhWnd != bhWnd) &&
				IsWindow(nhWnd) && IsWindowVisible(nhWnd) &&
			!IsIconic(nhWnd) && IsWindowEnabled(nhWnd) &&
			(GetWindowLong(nhWnd, GWL_STYLE) & ((WS_CAPTION | WS_SYSMENU) & ~WS_BORDER)) &&
			!(GetWindowLong(nhWnd, GWL_EXSTYLE) & NOTON)  ) break;
		nhWnd = GetWindow(nhWnd, GW_HWNDNEXT);
		if ( (nhWnd == fhWnd) || (nhWnd == NULL) ){
			nhWnd = fhWnd;
			break;
		}
	}
	if ( nhWnd == NULL ) nhWnd = dhWnd;
	while( (fhWnd = GetParent(nhWnd)) != NULL ){
		nhWnd = fhWnd;
	}
	SetForegroundWindow(nhWnd);
}

/*-----------------------------------------------------------------------------
	EBhE̕\
-----------------------------------------------------------------------------*/
void MoveClock(HWND hWnd)
{
	int offy;
	#define SETPOSMODE HWND_TOPMOST

	{ // j[\Ă邩ׁA\ĂƂ͕\Ȃ
		DWORD nowtick = GetTickCount();

		if ( nowtick != MoveClockInfo.PopFindTick ){
			MoveClockInfo.PopFindTick = nowtick;
			MoveClockInfo.hPopFindWnd = FindWindow(T("#32768"), NULL);
			if ( (MoveClockInfo.hPopFindWnd != NULL) &&
				 (IsWindowVisible(MoveClockInfo.hPopFindWnd) == FALSE) ){
				MoveClockInfo.hPopFindWnd = NULL;
			}
		}
		// j[\̂߁AړƂ߂
		if ( MoveClockInfo.hPopFindWnd != NULL ) return;
	}

	DPos.x = aRect.right - WindowSize.cx;
	DPos.y = aRect.top;
	offy = (textlines - 1) * FontSize.y;

	if ( DPosOff == &DPosOFFtemp ){			// ꎞړԂH ---------------
		DPos.x = DPosOff->x;
		DPos.y = DPosOff->y - offy;
		SetWindowPos(hWnd, SETPOSMODE, DPos.x, DPos.y,
				WindowSize.cx, WindowSize.cy, MoveClockInfo.Style);
		InvalidateRect(hWnd, NULL, FALSE);
		return;
	}
											// SʏԂH -----------------
	if (	(X_hide > 0) && ( ahWnd != dhWnd ) &&
			(aRect.left <= sRect.left) && (aRect.top <= sRect.top) &&
			(aRect.right >= sRect.right) && (aRect.bottom >= sRect.bottom) ){
		if ( (X_hide == 2) ||
			 (FindWindow(T("WindowsScreenSaverClass"), NULL) != NULL) ){
			// B
			SetWindowPos(hWnd, HWND_NOTOPMOST,
					DPos.x, DPos.y, WindowSize.cx, WindowSize.cy, SWP_HIDEWINDOW);
			MoveClockInfo.Style = SWP_NOACTIVATE | SWP_NOCOPYBITS | SWP_SHOWWINDOW;
			return;
		}
	}
	if ( IsZoomed(ahWnd) ){				// ő剻 -----------------------------
		DPosOff = &DPosOFFS[DPOS_MAXIMIZED];
	}else{
		int wndlen;
		wndlen = aWndLen ? aWndLen : OldaWndLen;
						 				// ^Cgo[Z or  ---------
		if ( ((aRect.right - aRect.left - ActiveWnd.BoxSize.cx ) <
				( CaptionIconX + (wndlen * CaptionFontX) + WindowSize.cx - DPosOFFS[DPOS_NORMAL].x) ) ||
			  !(ActiveWnd.Style & ((WS_CAPTION | WS_SYSMENU) & ~WS_BORDER)) ){
			DPosOff = &DPosOFFS[DPOS_THIN];
			DPos.y -= WindowSize.cy;
		}else{							// ʏ -------------------------------
			DPosOff = &DPosOFFS[DPOS_NORMAL];
		}
	}
	DPos.x += DPosOff->x - ActiveWnd.BoxSize.cx;
	DPos.y += DPosOff->y + ActiveWnd.BoxSize.cy;
	if ( (DPos.x < sRect.left) || (DPos.x >= (sRect.right - WindowSize.cx)) ||
		 (DPos.y < sRect.top) || ((DPos.y + WindowSize.cy) >= sRect.bottom) ){
		DPosOff = &DPosOFFS[DPOS_OUTRANGE];			// ͂ݏo
		DPos.x = sRect.right - WindowSize.cx + DPosOff->x;
		DPos.y = sRect.top + DPosOff->y;
	}

	if ( NearPointer ){
		DPos.x -= WindowSize.cx;

		if ( DPos.x >= (sRect.right - WindowSize.cx) ){
			DPos.x = sRect.right - WindowSize.cx;
		}
		if ( (DPos.y - offy) >= (sRect.bottom - WindowSize.cy) ){
			DPos.y = sRect.bottom - WindowSize.cy + offy;
		}
		if ( DPos.x < sRect.left ) DPos.x = sRect.left;
		if ( (DPos.y - offy) < sRect.top ) DPos.y = sRect.top + offy;
	}

	if ( LappedTaskBar && !NearPointer ){	// ^XNo[ɏdȂĂ鎞
		SetWindowPos(hWnd, SETPOSMODE,
				sRect.right - WindowSize.cx + DPosOFFS[DPOS_ONTASKBAR].x,
				DPosOFFS[DPOS_ONTASKBAR].y,
				WindowSize.cx, WindowSize.cy, MoveClockInfo.Style);
	}else{
		DPos.y -= offy;
		SetWindowPos(hWnd, SETPOSMODE, DPos.x, DPos.y,
				WindowSize.cx, WindowSize.cy, MoveClockInfo.Style);
	}
	MoveClockInfo.Style = SWP_NOACTIVATE | SWP_NOCOPYBITS;
	InvalidateRect(hWnd, NULL, FALSE);
}
/*-----------------------------------------------------------------------------
	ANeBuEBhE擾
-----------------------------------------------------------------------------*/
#define VALIDSTYLEMASK (WS_DISABLED | WS_VISIBLE)
#define VALIDSTYLEFLAG WS_VISIBLE

HWND GetPWindow(void)
{
	HWND hFirstWnd, hWnd;

	hFirstWnd = hWnd = GetForegroundWindow();
	for(;;){
		if (	(hWnd != dhWnd) && IsWindow(hWnd) &&
				((GetWindowLong(hWnd, GWL_STYLE) & VALIDSTYLEMASK) ==
						VALIDSTYLEFLAG) && !IsIconic(hWnd) &&
				!(GetWindowLong(hWnd, GWL_EXSTYLE) & NOTON) ){
			break;
		}
		hWnd = GetWindow(hWnd, GW_HWNDNEXT);
		if ( (hWnd == hFirstWnd) || (hWnd == NULL) ){
			hWnd = NULL;
			break;
		}
	}
	if ( hWnd == NULL ) hWnd = dhWnd;
	return hWnd;
}
/*-----------------------------------------------------------------------------
	ANeBuEBhȄ擾
-----------------------------------------------------------------------------*/
void GetWndStyle(void)
{
								// EBhĚ`
	ActiveWnd.Style = GetWindowLong(ahWnd, GWL_STYLE);
	if ( ActiveWnd.Style & WS_THICKFRAME ){
		ActiveWnd.BoxSize.cx = GetSystemMetrics(SM_CXFRAME);
		ActiveWnd.BoxSize.cy = GetSystemMetrics(SM_CYFRAME);
	} else if ( ActiveWnd.Style & WS_DLGFRAME ){
		ActiveWnd.BoxSize.cx = GetSystemMetrics(SM_CXDLGFRAME);
		ActiveWnd.BoxSize.cy = GetSystemMetrics(SM_CYDLGFRAME);
	} else if ( ActiveWnd.Style & WS_BORDER ){
		ActiveWnd.BoxSize.cx = GetSystemMetrics(SM_CXBORDER);
		ActiveWnd.BoxSize.cy = GetSystemMetrics(SM_CYBORDER);
	} else {
		ActiveWnd.BoxSize.cx = 0;
		ActiveWnd.BoxSize.cy = 0;
	}
}

//------------------------------------- zbgL[蓖Ă
void SetHotKey(HWND hWnd, int id, int hotkey)
{
	UnregisterHotKey(hWnd, id);
	if ( hotkey & 0xff ){
		RegisterHotKey(hWnd, id,
					((hotkey & B16) ? MOD_SHIFT : 0) |
					((hotkey & B17) ? MOD_CONTROL : 0) |
					((hotkey & B18) ? MOD_ALT : 0), LOWORD(hotkey));
	}
	return;
}
//------------------------------------- eEBhE𐄑
HWND GetParentBox(HWND hWnd)
{
	HWND nhWnd;

	nhWnd = hWnd;
	while ( (nhWnd = GetParent(nhWnd)) != NULL){
		if ( GetWindowLong(nhWnd, GWL_STYLE) & ((WS_CAPTION | WS_SYSMENU) & ~WS_BORDER) ){
			return nhWnd;
		}
	}
	nhWnd = GetParent(hWnd);
	return nhWnd;
}
//-------------------------------- EBhEeEBhÊ܂񒆂Ɉړ
void CenterWindow(HWND hWnd)
{
	RECT	box, pbox;
	HWND	thWnd;

	thWnd = GetParentBox(hWnd);

	GetWindowRect(hWnd, &box);
	if (thWnd){
		GetWindowRect(thWnd, &pbox);
	}else{
		pbox = sRect;
	}
								// ƍɕϊ
	box.right -= box.left;
	box.bottom -= box.top;

								// Ɉړ
	box.left = pbox.left + (( (pbox.right  - pbox.left) - box.right  ) >> 1);
	box.top  = pbox.top  + (( (pbox.bottom - pbox.top ) - box.bottom ) >> 1);

								// E͂ݏoĂ邩H
	if ( (box.left + box.right) > sRect.right ){
		box.left = sRect.right - box.right;
	}
	if ( box.left < sRect.left ) box.left = sRect.left;

								// ㉺͂ݏoĂ邩H
	if ( (box.top + box.bottom) > sRect.bottom ){
		box.top = sRect.bottom - box.bottom;
	}
	if ( box.top < sRect.top ) box.top = sRect.top;

	MoveWindow(hWnd, box.left, box.top, box.right, box.bottom, FALSE);
}

void SetForegroundWindow98(HWND hWnd)
{
	DWORD inactiveTID, activeTID;

	inactiveTID	= GetWindowThreadProcessId(hWnd, NULL);
	activeTID	= GetWindowThreadProcessId(GetForegroundWindow(), NULL);
	AttachThreadInput(inactiveTID, activeTID, TRUE);
	SetForegroundWindow(hWnd);
	AttachThreadInput(inactiveTID, activeTID, FALSE);
}

HINSTANCE hCPodDLL = NULL;
DefineWinAPI(BOOL, HookSwitch, (BOOL sw));
const TCHAR ClockPod32Name[] = T("CLOCKPOD.EXE");
const TCHAR ClockPod32Param[] = T("*");

void UseCPodDLL(int useflag)
{
	if ( useflag ){
		if ( hCPodDLL != NULL ) return;
		hCPodDLL = LoadLibraryA(CLOCKPODDLLNAME);
		if ( hCPodDLL != NULL ){
			GETDLLPROC(hCPodDLL, HookSwitch);
			if ( DHookSwitch != NULL ) DHookSwitch(TRUE);
		}
		#ifdef _WIN64
			ShellExecute(NULL, NULL, ClockPod32Name, ClockPod32Param, NULL, 0);
		#endif
	}else{
		if ( hCPodDLL == NULL ) return;
		if ( DHookSwitch != NULL ) DHookSwitch(FALSE);
		FreeLibrary(hCPodDLL);
		hCPodDLL = NULL;
		#ifdef _WIN64
		{
			HWND h32Wnd = FindWindow(AppNameHolderStr, AppNameHolderStr);
			if ( h32Wnd != NULL ) PostMessage(h32Wnd, WM_CLOSE, 0, 0);
		}
		#endif
	}
}

void SetDefaultCursor(HWND hWnd, const TCHAR *iconname)
{
	HICON hNewIcon;

	hNewIcon = LoadCursor(NULL, iconname);
	SetClassLongPtr(hWnd, GCLP_HCURSOR, (LONG_PTR)hNewIcon);
	SetCursor(hNewIcon);
}

//==================================================================== J_
typedef struct {
	DWORD dwSize;
	DWORD dwICC;
} INITCOMMONCONTROLSEXSTRUCT;

INITCOMMONCONTROLSEXSTRUCT UseCommonControls = {
	sizeof(INITCOMMONCONTROLSEXSTRUCT), 0
};

HANDLE hComctl32 = NULL;
//  -------------------------------
HANDLE LoadCommonControls(DWORD usecontrol)
{
	DefineWinAPI(void, InitCommonControls, (void));
	DefineWinAPI(void, InitCommonControlsEx, (INITCOMMONCONTROLSEXSTRUCT *));

	if ( hComctl32 != NULL ){	// sς
		if ( !UseCommonControls.dwICC ) return hComctl32;
	}else{
		hComctl32 = LoadLibraryA("COMCTL32.DLL");
		if ( hComctl32 == NULL ) return NULL;
		GETDLLPROC(hComctl32, InitCommonControlsEx);
		if ( DInitCommonControlsEx ){
			UseCommonControls.dwICC = 0;
		}else{
			GETDLLPROC(hComctl32, InitCommonControls);
			if ( DInitCommonControls != NULL ) DInitCommonControls();
			return hComctl32;
		}
	}
	if ( !(UseCommonControls.dwICC & usecontrol) ){	// ܂[h
		setflag(UseCommonControls.dwICC, usecontrol);
		GETDLLPROC(hComctl32, InitCommonControlsEx);
		DInitCommonControlsEx(&UseCommonControls);
	}
	return hComctl32;
}

#define ICC_DATE_CLASSES     0x00000100

void ShowCarendar(HWND hWnd)
{
	RECT boxS, boxC, boxCtrl;

	if ( (hCarendar == NULL) || (IsWindow(hCarendar) == FALSE) ){
		LoadCommonControls(ICC_DATE_CLASSES);
		hCarendar = CreateWindowEx(WS_EX_CLIENTEDGE | WS_EX_DLGMODALFRAME,
			MONTHCAL_CLASS, MONTHCAL_CLASS,
			WS_CAPTION | WS_THICKFRAME | WS_POPUPWINDOW ,
			0, 0, 0, 0, hWnd, NULL, hMainInst, 0);
		if ( hCarendar == NULL ) return;
	}else{
		return;
	}
	GetWindowRect(hCarendar, &boxS);
	GetClientRect(hCarendar, &boxC);
	MonthCal_GetMinReqRect(hCarendar, &boxCtrl);
	boxCtrl.right +=  (boxS.right - boxS.left) - (boxC.right - boxC.left) -
			boxCtrl.left;
	boxCtrl.bottom += (boxS.bottom - boxS.top) - (boxC.bottom - boxC.top) -
			boxCtrl.top;

	GetWindowRect(hWnd, &boxS);
	MoveWindow(hCarendar, boxS.left, boxS.bottom, //top - boxCtrl.bottom,
			boxCtrl.right, boxCtrl.bottom, FALSE);
	ShowWindow(hCarendar, SW_SHOWNOACTIVATE);
}

void CloseCarendar(void)
{
	if ( hCarendar != NULL ){
		DestroyWindow(hCarendar);
		hCarendar = NULL;
	}
}


BOOL TrayMessage(HWND hWnd, DWORD Message, WORD Icon, const TCHAR *TipStr, const TCHAR *BalloonStr)
{
	NOTIFYICONDATA5 tnd;

	if ( hShell32 == NULL ){
		hShell32 = LoadLibraryA("SHELL32.DLL");
		if ( hShell32 == NULL ) return FALSE;
		GETDLLPROCT(hShell32, Shell_NotifyIcon);
		if ( DShell_NotifyIcon == NULL ) return FALSE;
	}

	tnd.cbSize = sizeof(NOTIFYICONDATA5);
	tnd.hWnd = hWnd;
	tnd.uID = TRAYID;
	tnd.uFlags = NIF_MESSAGE;
	tnd.uCallbackMessage = WM_TRAY_T;
	if ( Icon ){
		tnd.hIcon = LoadIcon(hMainInst, MAKEINTRESOURCE(Icon));
		setflag(tnd.uFlags, NIF_ICON);
	}
	if ( TipStr != NULL ){
		setflag(tnd.uFlags, NIF_TIP);
		tstrcpy(tnd.szTip, TipStr);
	}
	if ( BalloonStr != NULL ){
		setflag(tnd.uFlags, NIF_INFO);
		tstrcpy(tnd.szInfoTitle, ClockPodStr);
		if ( tstrlen(BalloonStr) >= NIF_INFO_STRMAX ){
			memcpy(tnd.szInfo, BalloonStr, (NIF_INFO_STRMAX - 1) * sizeof(TCHAR));
			tnd.szInfo[NIF_INFO_STRMAX - 1] = '\0';
		}else{
			tstrcpy(tnd.szInfo, BalloonStr);
		}
		tstrcpy(BallonText, tnd.szInfo);
		UNIONNAME(tnd, uTimeout) = 0x7fffffff;
		tnd.dwInfoFlags = 0;
	}
	return DShell_NotifyIcon(Message, (NOTIFYICONDATA *)&tnd);
}

int GetMonitorDPI(HWND hWnd)
{
	UINT dpiX, dpiY;
	HDC hDC;

	if ( hWnd == NULL ) hWnd = GetFocus();

		if ( DMonitorFromWindow == NULL ){
			GETDLLPROC(GetModuleHandleA("USER32.DLL"), MonitorFromWindow);
		}

	if ( (DGetDpiForMonitor == NULL) && (hShcore == NULL) ){
		hShcore = LoadLibrary(T("shcore.dll"));
		if ( hShcore != NULL ){
			GETDLLPROC(hShcore, GetDpiForMonitor);
		}else{
			hShcore = INVALID_VALUE(HMODULE);
		}
	}
	if ( (DGetDpiForMonitor != NULL) && (DMonitorFromWindow != NULL) ){
		HMONITOR hMonitor;

		hMonitor = DMonitorFromWindow(hWnd, MONITOR_DEFAULTTONEAREST);
		if ( hMonitor != NULL ){
			DGetDpiForMonitor(hMonitor, xMDT_EFFECTIVE_DPI, &dpiX, &dpiY);
			return (int)dpiX;
		}
	}

	hDC = GetDC(hWnd);
	dpiX = GetDeviceCaps(hDC, LOGPIXELSX);
	ReleaseDC(hWnd, hDC);

	return (int)dpiX;
}

#ifdef UNICODE
WCHAR *wcslimcpy(WCHAR *deststr, const WCHAR *srcstr, size_t maxlength)
{
	size_t len;

	len = strlenW(srcstr);
	if ( len >= maxlength ){
		WCHAR *last;

		memcpy(deststr, srcstr, (maxlength - 1) * sizeof(WCHAR));
		last = deststr + (maxlength - 1);
		*last = '\0';
		return last;
	}else{
		memcpy(deststr, srcstr, (len + 1) * sizeof(WCHAR));
		return deststr + len;
	}
}
#else
char *strlimcpy(char *deststr, const char *srcstr, size_t maxlength)
{
	size_t len;

	len = strlen(srcstr);
	if ( len >= maxlength ){
		char *last;

		memcpy(deststr, srcstr, maxlength - 1);
		last = deststr + (maxlength - 1);
		*last = '\0';
		return last;
	}else{
		memcpy(deststr, srcstr, len + 1);
		return deststr + len;
	}
}
#endif

LPDLGTEMPLATE GetDialogTemplate(HANDLE hinst, LPCTSTR lpszTemplate)
{
	BYTE *dialog;
	HRSRC hRc;
	DWORD dialogsize, fontlength;
	int i;
	BYTE *dp, *dpitem;
	WCHAR fontdata[LF_FACESIZE + 1];
	NONCLIENTMETRICS ncm;

	ncm.cbSize = sizeof(ncm);
	SystemParametersInfo(SPI_GETNONCLIENTMETRICS, sizeof(ncm), &ncm, 0);

	// fontlength : lfFaceName ̕(\0܂) + word(fontsize)
	// fontlengthpoint\L̂߁AlfFaceName(px)班傫Ȃ
#ifdef UNICODE
	fontlength = ((DWORD)wcslen(ncm.lfMessageFont.lfFaceName) + 2) * sizeof(WCHAR);
	memcpy(&fontdata[1], ncm.lfMessageFont.lfFaceName, fontlength - sizeof(WCHAR));
#else
	fontlength = (MultiByteToWideChar(CP_ACP, MB_PRECOMPOSED,
			ncm.lfMessageFont.lfFaceName, -1, &fontdata[1],
			sizeof(fontdata) / sizeof(WCHAR) - 2) + 1) * sizeof(WCHAR);
#endif
									// ev[g̓ǂݍ
	hRc = FindResource(hinst, lpszTemplate, RT_DIALOG);
	if ( hRc == NULL ) return NULL;
	dialogsize = SizeofResource(hinst, hRc);
	dialog = (BYTE *)HeapAlloc(GetProcessHeap(), 0, dialogsize + fontlength + sizeof(WORD));
	memcpy(dialog, LockResource(LoadResource(hinst, hRc)), dialogsize);

									// j[ANXA^Cg΂
	dp = dialog + (sizeof(DWORD) * 2 + sizeof(WORD) * 5); // DLGTEMPLATE 

	// tHgTCY(pixelłȂAPt)
	if ( ncm.lfMessageFont.lfHeight < 0 ){
		ncm.lfMessageFont.lfHeight = -ncm.lfMessageFont.lfHeight;
	}
	fontdata[0] = (WCHAR)ncm.lfMessageFont.lfHeight;

	for ( i = 0 ; i < 3 ; i++ ){
		WORD id;

		id = *(WORD *)dp;
		if ( id == 0 ){			// Ȃ
			dp += sizeof(WORD);
		}else if ( id == 0 ){	// ATOM
			dp += sizeof(WORD) * 2;
		}else {
			dp += sizeof(WORD);
			while( *dp ) dp += sizeof(WORD);
			dp += sizeof(WORD);
		}
	}
	dpitem = dp;
									// K̃tHgΔ΂
	if ( ((DLGTEMPLATE *)dialog)->style & DS_SETFONT ){
		dpitem += sizeof(WORD);
		while( *dpitem ) dpitem += sizeof(WORD);
		dpitem += sizeof(WORD);
	}
								// dword ␳1
	if ( ((DWORD)(BYTE *)dpitem) & 3 ) dpitem += sizeof(WORD); // C4305ok
								// dword ␳2
	if ( (((DWORD)(BYTE *)dp) + fontlength) & 3 ) fontlength += sizeof(WORD);
									// ev[g̏C
	setflag(((DLGTEMPLATE *)dialog)->style, DS_SETFONT);
	memmove(dp + fontlength, dpitem, dialogsize - (dpitem - dialog));
	memcpy(dp, fontdata, fontlength);

	return (LPDLGTEMPLATE)dialog;
}

INT_PTR ExtDialogBoxParam(HANDLE hinst, const TCHAR *lpszTemplate, HWND hwndOwner, DLGPROC dlgprc, LPARAM lParamInit)
{
	LPDLGTEMPLATE dialog;
	INT_PTR result;

	dialog = GetDialogTemplate(hinst, lpszTemplate);
	if ( dialog == NULL ) return -1;
	result = DialogBoxIndirectParam(hinst, dialog, hwndOwner, dlgprc, lParamInit);
	HeapFree(GetProcessHeap(), 0, dialog);
	return result;
}

HWND ExtCreateDialogParam(HANDLE hinst, const TCHAR *lpszTemplate, HWND hwndOwner, DLGPROC dlgprc, LPARAM lParamInit)
{
	LPDLGTEMPLATE dialog;
	HWND result;

	dialog = GetDialogTemplate(hinst, lpszTemplate);
	if ( dialog == NULL ) return NULL;
	result = CreateDialogIndirectParam(hinst, dialog, hwndOwner, dlgprc, lParamInit);
	HeapFree(GetProcessHeap(), 0, dialog);
	return result;
}
