/*-----------------------------------------------------------------------------
	HDTEMP header
-----------------------------------------------------------------------------*/
#define TRAYMODE		0			// ^XNgCłgpƂ(for debug)

#define ERROR_WAIT		3000		// G[̑ҋ@b
#define PIPEWAITTIME	60000		// pCv̋󂫑҂b

#define PipeName		"\\\\.\\pipe\\HWINFS"
#define PipeBuffers		0x800		// pCvpobt@̑傫
#define PipeReadBuffers	0x200		// pCv̌ʎMpobt@
									//  WinXP SP2 ł 0x700 zȂ
#define RCS_COPYRIGHT	APPNAME " Ver" VERSIONS " " COPYRIGHT

// SMART ̒`

#pragma pack(push,1)

#ifndef READ_ATTRIBUTES
#define READ_ATTRIBUTES 0xD0
#define SMART_CYL_LOW 0x4F
#define SMART_CYL_HI  0xC2
#define READ_ATTRIBUTE_BUFFER_SIZE 512

typedef struct tagIDEREGS {
	BYTE bFeaturesReg;
	BYTE bSectorCountReg;
	BYTE bSectorNumberReg;
	BYTE bCylLowReg;
	BYTE bCylHighReg;
	BYTE bDriveHeadReg;
	BYTE bCommandReg;
	BYTE bReserved;
} IDEREGS;

typedef struct tagDRIVERSTATUS {
	BYTE bDriverError;
	BYTE bIDEError;
	BYTE bReserved[2];
	DWORD dwReserved[2];
} DRIVERSTATUS, *PDRIVERSTATUS, *LPDRIVERSTATUS;

typedef struct tagSENDCMDINPARAMS {
	DWORD cBufferSize;
	IDEREGS irDriveRegs;
	BYTE bDriveNumber;
	BYTE bReserved[3];
	DWORD dwReserved[4];
	BYTE bBuffer[1];
} SENDCMDINPARAMS;

typedef struct tagSENDCMDOUTPARAMS {
	DWORD cBufferSize;
	DRIVERSTATUS DriverStatus;
	BYTE bBuffer[1];
} SENDCMDOUTPARAMS;
#endif

#define ATAPI_SMART (BYTE)0xB0
#define ATAPI_SMART_THRESHOLD (BYTE)0xD1
#define ATAPI_IDENTIFY (BYTE)0xEC

#define DFP_RECEIVE_DRIVE_DATA 0x7C088
typedef struct tagDRIVEATTRIBUTE {
	BYTE bAttrID;
	WORD wStatusFlags;
	BYTE bAttrValue;
	BYTE bWorstValue;
	BYTE bRawValue[6];
	BYTE bReserved;
} DRIVEATTRIBUTE;

typedef struct tagATTRIBUTETHRESHOLD {
	BYTE bAttrID;
	BYTE bWarrantyThreshold;
	BYTE bReserved[10];
} ATTRIBUTETHRESHOLD;
#pragma pack(pop)
