/*=============================================================================
	ClockPodɃbZ[W𑗐M									(c)TORO
=============================================================================*/
#define STRICT
#include <windows.h>
#pragma hdrstop

#define MailSlotName	"\\mailslot\\CPODslot"

#define UnicodeToUtf8(unicode, utf8, destsize) WideCharToMultiByte(CP_UTF8, 0, unicode, -1, utf8, destsize, NULL, NULL)
#define UTF8HEADER "\xef\xbb\xbf"
#define UTF8HEADERSIZE 3
#define U__STR(string)	L##string
#define UNICODESTR(string)	U__STR(string)
#define MessageA(mes)	MessageBoxA(NULL, mes, NULL, MB_OK)
#define MessageW(mes)	MessageBoxW(NULL, mes, NULL, MB_OK)

BYTE GetLineParamA(const char **str, char *param, int size);
WCHAR GetLineParamW(const WCHAR **str, WCHAR *param, int size);
void SendMailSlot(char *userA, WCHAR *userW, char *message);

#pragma argsused
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int cmdShow)
{
	const char *CmdLinePtrA = lpszCmdLine;
	const WCHAR *CmdLinePtrW = GetCommandLineW();
	char userA[MAX_PATH], mesA[1000];
	WCHAR userW[MAX_PATH], mesW[1000];
	OSVERSIONINFO osver;
	BOOL unicodemode = FALSE;

	osver.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
	GetVersionEx(&osver);
	if ( osver.dwMajorVersion >= 5 ){ // Ver4 ȑO CP_UTF8 gȂꍇL
		unicodemode = TRUE;
		GetLineParamW(&CmdLinePtrW, mesW, sizeof(mesW));
	}

	for (;;){
		if ( unicodemode != FALSE ){
			if ( !GetLineParamW(&CmdLinePtrW, userW, sizeof(userW)) ) break;
			if ( !GetLineParamW(&CmdLinePtrW, mesW, sizeof(mesW)) ) break;
			userA[0] = '\0';
			memcpy(mesA, UTF8HEADER, UTF8HEADERSIZE);
			UnicodeToUtf8(mesW, mesA + UTF8HEADERSIZE, MAX_PATH);
		}else{
			if ( !GetLineParamA(&CmdLinePtrA, userA, sizeof(userA)) ) break;
			if ( !GetLineParamA(&CmdLinePtrA, mesA, sizeof(mesA)) ) break;
		}
		SendMailSlot(userA, userW, mesA);
		return EXIT_SUCCESS;
	}
	MessageBoxA(NULL,
			"PODSEND (c)TORO 2001-2018\n"
			"usage:PODSEND user message", NULL, MB_OK);
	return EXIT_FAILURE;
}
//------------------------------------- bZ[W𑗐M
void SendMailSlot(char *userA, WCHAR *userW, char *message)
{
	HANDLE hFile;
	DWORD size;

	if ( userA[0] != '\0' ){
		char nameA[MAX_PATH + 2];

		wsprintfA(nameA, "\\\\%s" MailSlotName, userA);
		hFile = CreateFileA(nameA, GENERIC_WRITE, FILE_SHARE_READ,
				NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	}else{
		WCHAR nameW[MAX_PATH + 2];

		wsprintfW(nameW, L"\\\\%s" UNICODESTR(MailSlotName), userW);
		hFile = CreateFileW(nameW, GENERIC_WRITE, FILE_SHARE_READ,
				NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	}
	if ( hFile != INVALID_HANDLE_VALUE ){
		WriteFile(hFile, message, (DWORD)(strlen(message) + 1), &size, NULL);
		CloseHandle(hFile);
	}
}
//------------------------------------- (space, tabjXLbv
BYTE SkipSpace(const char **str)
{
	BYTE code;

	for (;;){
		code = **str;
		if ( (code != ' ') && (code != '\t') ) break;
		(*str)++;
	}
	return code;
}
WCHAR SkipSpaceW(const WCHAR **str)
{
	WCHAR code;

	for (;;){
		code = **str;
		if ( (code != ' ') && (code != '\t') ) break;
		(*str)++;
	}
	return code;
}
/*-----------------------------------------------------------------------------
	R}hCp[^Po
IN		str:R}hC			param:op[^
		size:ݐ̑傫
RET:	==0 :EOL/Error	!=0 :p[^̂P
		p[^傫ꍇ́A߂l0ƂȂAparamɓ
		@E܂Ńp[^BAG[̂Ƃ *param == 0
-----------------------------------------------------------------------------*/
BYTE GetLineParamA(const char **str, char *param, int size)
{
	BYTE code, bottom;
	const char *src;
										// 擪󔒂XLbv -----------------
	src = *str;
	bottom = SkipSpace(&src);
	if ( bottom == '\0' ){
		*str = src;
		*param = '\0';
		return '\0';
	}
	src++;
	size--;
	if ( bottom == '\"' ){				// u"vň͂ ------------------------
		bottom = *src;
		while( '\0' != (code = *src) ){
			src++;
			if ( (code == '\"') && (*src <= ' ') ) break;
			if ( size ){
				*param++ = code;
				size--;
			}
		}
	}else{								// u"vň͂Ȃ --------------------
		*param++ = bottom;
		size--;
		while( '\0' != (code = *src) ){
			src++;
			if ( code <= ' ' ) break;
			if ( size ){
				*param++ = code;
				size--;
			}
		}
	}
	*param = '\0';
	*str = src;
	return size ? bottom : (BYTE)'\0';
}
WCHAR GetLineParamW(const WCHAR **str, WCHAR *param, int size)
{
	WCHAR code, bottom;
	const WCHAR *src;
										// 擪󔒂XLbv -----------------
	src = *str;
	bottom = SkipSpaceW(&src);
	if ( bottom == '\0' ){
		*str = src;
		*param = 0;
		return 0;
	}
	src++;
	size--;
	if ( bottom == '\"' ){				// u"vň͂ ------------------------
		bottom = *src;
		while( '\0' != (code = *src) ){
			src++;
			if ( (code == '\"') && (*src <= ' ') ) break;
			if ( size ){
				*param++ = code;
				size--;
			}
		}
	}else{								// u"vň͂Ȃ --------------------
		*param++ = bottom;
		size--;
		while( '\0' != (code = *src) ){
			src++;
			if ( code <= ' ' ) break;
			if ( size ){
				*param++ = code;
				size--;
			}
		}
	}
	*param = '\0';
	*str = src;
	return size ? bottom : (WCHAR)'\0';
}
