/*-----------------------------------------------------------------------------
	`t@CpbP[W								(c)TORO 2000,01,05
-----------------------------------------------------------------------------*/
#define STRICT
#include <windows.h>
#include "TOROWIN.H"
#include "CHRTYPE.H"
#include "CFG.H"

//======================================================================== Gp
//------------------------------------- c 啶
TCHAR USEFASTCALL upper(TCHAR c)
{
	if ( Islower(c) ) c = (TCHAR)(c - 0x20);
	return c;
}
/*-------------------------------------
 another strrchrBYȂ
 Ԃ
-------------------------------------*/
TCHAR * USEFASTCALL strschr(const TCHAR *string, TCHAR chr)
{
	const TCHAR *ptr;

	ptr = tstrrchr(string, chr);
	if ( ptr != NULL ) return (TCHAR *)ptr;
	return (TCHAR *)string + tstrlen(string);
}
/*-------------------------------------
 t@CpX src ̌ fname 
 ABʂ dst/src ̂ꂩ
-------------------------------------*/
void CatPath(TCHAR *dst, TCHAR *src, const TCHAR *fname)
{
	TCHAR *sep;	// u\v̈ʒuoĂ
	TCHAR *readp;
	int len;

	sep = src;
	if ( dst == NULL ){				// src Ɍʂi[ -------------------
		readp = src;
		while ( *readp ){
			if ( *readp == '\\' ) sep = readp + 1;
			#ifndef UNICODE
				if ( IskanjiA(*readp++) ){
					if ( *readp ) readp++;
				}
			#else
				readp++;
			#endif
		}
		if ( sep != readp ) *(readp++) = '\\';

		len = tstrlen32(fname) + 1;
		if ( (readp - src + len) >= MAX_PATH ){
			tstrcpy(src, T("<too long>"));
			return;
		}
		memcpy(readp, fname, TSTROFF(len));
		return;
	}else{							// dst Ɍʂi[ -------------------
		readp = src;
		while ( *readp ){
			if ( *readp == '\\' ) sep = readp + 1;
			#ifndef UNICODE
				if ( IskanjiA(*dst++ = *readp++) ){
					if ( *readp ) *dst++ = *readp++;
				}
			#else
				*dst++ = *readp++;
			#endif
		}
		if ( sep != readp ){
			*(dst++) = '\\';
			readp++;
		}
		len = tstrlen32(fname) + 1;
		if ( (readp - src + len) >= MAX_PATH ){
			tstrcpy(dst - (readp - src), T("<too long>"));
			return;
		}
		memcpy(dst, fname, TSTROFF(len));
		return;
	}
}

/*-------------------------------------
	s(\0,\a,\d)H

RET:	==0 :EOL	!=0 :Code
-------------------------------------*/
UTCHAR USEFASTCALL IsEOL(LPCTSTR *str)
{
	UTCHAR code;

	code = **str;
	if ( code == 0 ) return 0;
	if ( code == 0xd ){
		if ( *(*str + 1) == 0x0a ) (*str)++;
		return 0;
	}
	if ( code == 0xa ){
		if ( *(*str + 1) == 0x0d ) (*str)++;
		return 0;
	}
	return code;
}
/*-------------------------------------
	(space, tabjXLbv

RET:	==0 :EOL	!=0 :Code
--------------------------------------*/
UTCHAR USEFASTCALL SkipSpace(LPCTSTR *str)
{
	UTCHAR code;

	for(;;){
		code = IsEOL(str);
		if ( (code != ' ') && (code != '\t') ) break;
		(*str)++;
	}
	return code;
}
/*-------------------------------------
	̃p[^𒊏oB
	擪Ɩ̋󔒂͏

RET:	擪̕(Ȃ 0)
-------------------------------------*/
UTCHAR GetLineParam(LPCTSTR *str, TCHAR *param)
{
	UTCHAR code, bottom;
	const TCHAR *src;
	TCHAR *dst;

	src = *str;
	dst = param;
	bottom = SkipSpace(&src);
	if ( bottom == '\0' ){
		*str = src;
		return '\0';
	}
	src++;
	if ( bottom == '\"' ){
		bottom = *src;
		while( '\0' != (code = IsEOL(&src)) ){
			src++;
			if ( (code == '\"') && (*src <= ' ') ) break;
			*dst++ = code;
		}
	}else{
		*dst++ = bottom;
		while( '\0' != (code = IsEOL(&src)) ){
			src++;
			if ( code <= ' ' ) break;
			*dst++ = code;
		}
	}
	*dst = '\0';
	*str = src;
	return bottom;
}
/*-------------------------------------
 WXg當𓾂
  path  dest ϐł薳
-------------------------------------*/
BOOL GetRegString(HKEY hKey, const TCHAR *path, const TCHAR *name, TCHAR *dest, DWORD size)
{
	HKEY HK;
	DWORD type, sz;

	if ( RegOpenKeyEx(hKey, path, 0, KEY_READ, &HK) == ERROR_SUCCESS ){
		sz = size;
		if ( RegQueryValueEx(HK, name, NULL, &type, (LPBYTE)dest, &sz) == ERROR_SUCCESS ){
			if ( type == REG_EXPAND_SZ ){
				TCHAR buf[MAX_PATH];

				tstrcpy(buf, dest);
				ExpandEnvironmentStrings(buf, dest, size);
			}
			RegCloseKey(HK);
			return TRUE;
		}
		RegCloseKey(HK);
	}
	return FALSE;
}
//================================================================ oCi
//------------------------------------- 16 ioCiɕϊ
DWORD ReadHex(const TCHAR **srchex, void *destbin, DWORD binsize)
{
	const TCHAR *src;
	BYTE *dest, l, h;
	DWORD destlen = 0;

	src = *srchex;
	while( *src == ' ' ) src++;
	dest = destbin;
	while( binsize ){
		h = (BYTE)upper(*src);
		if ( !Isxdigit(h) ) break;
		l = (BYTE)upper(*(src + 1));
		if ( !Isxdigit(l) ) break;
		src += 2;
		if ( (h = (BYTE)(h - '0')) > 9 ) h = (BYTE)(h - 7);
		if ( (l = (BYTE)(l - '0')) > 9 ) l = (BYTE)(l - 7);
		*dest++ = (BYTE)((h << 4) + l);
		binsize--;
		destlen++;
	}
	*srchex = src;
	return destlen;
}
//------------------------------------- oCi 16 iɕϊ
void WriteHex(TCHAR *desthex, const void *srcbin, DWORD binsize)
{
	BYTE *src = (BYTE *)srcbin;

	for ( ; binsize != 0 ; binsize-- ){
		desthex += wsprintf(desthex, T("%02x"), *src);
		src++;
	}
}
//------------------------------------- oCỉǐ^ɖ߂
void MaskingBinary(char *str, int size)
{
	char user[0x100], *up = user;
	DWORD tmp;

	tmp = sizeof(user);
	GetUserNameA(user, &tmp);

	if ( *up ) if ( !*(++up) ) up = user;
	for ( ; size ; size-- ){
		*str = (char)(*str ^ *up ^ size);
		str++;
		if ( *(++up) == '\0' ) up = user;
	}
}
//============================================================ `t@C
//------------------------------------- `t@Cǂݍ
BOOL CFGOpen(CFG *cfg, const TCHAR *filename)
{
	HANDLE hFile;

	cfg->bottom = NULL;
	cfg->size = 0;
	cfg->write = 0;
	tstrcpy(cfg->filename, filename);

	hFile = CreateFile(filename, GENERIC_READ, FILE_SHARE_READ, NULL,
			OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if ( hFile == INVALID_HANDLE_VALUE ){
		// Ă̈͊mۂ
		cfg->size = 0;
		cfg->bottom = HeapAlloc(GetProcessHeap(), 0, CFG_MARGIN);
		if ( cfg->bottom == NULL ) return FALSE;
	}else{
#ifdef UNICODE
		DWORD sizeA;
		char *dataA;
		int Utf8offset = -1;

		sizeA = GetFileSize(hFile, NULL);
		dataA = HeapAlloc(GetProcessHeap(), 0, sizeA);
		if ( dataA == NULL ){
			CloseHandle(hFile);
			return FALSE;
		}
		ReadFile(hFile, dataA, sizeA, &sizeA, NULL);
		if ( memcmp(dataA, UTF8HEADER, UTF8HEADERSIZE) == 0 ){ // UTF-8
			cfg->size = MultiByteToWideChar(CP_UTF8, 0, dataA + UTF8HEADERSIZE, sizeA - UTF8HEADERSIZE, NULL, 0);
			Utf8offset = UTF8HEADERSIZE;
		}else{ // ANSI
			if ( (cfg->size = MultiByteToWideChar(CP_UTF8, MB_ERR_INVALID_CHARS, dataA, sizeA, NULL, 0)) != 0 ){
				Utf8offset = 0;
			}else{
				cfg->size = MultiByteToWideChar(CP_ACP, 0, dataA, sizeA, NULL, 0);
			}
		}
		cfg->bottom = HeapAlloc(GetProcessHeap(), 0, cfg->size * sizeof(WCHAR) + CFG_MARGIN * sizeof(WCHAR));
		if ( cfg->bottom == NULL ){
			CloseHandle(hFile);
			return FALSE;
		}
		if ( Utf8offset >= 0 ){ // UTF-8
			MultiByteToWideChar(CP_UTF8, 0, dataA + Utf8offset, sizeA - UTF8HEADERSIZE, cfg->bottom, cfg->size);
		}else{
			MultiByteToWideChar(CP_ACP, 0, dataA, sizeA, cfg->bottom, cfg->size);
		}
		HeapFree(GetProcessHeap(), 0, dataA);
#else
		cfg->size = GetFileSize(hFile, NULL);
		cfg->bottom = HeapAlloc(GetProcessHeap(), 0, cfg->size + CFG_MARGIN);
		if ( cfg->bottom == NULL ){
			CloseHandle(hFile);
			return FALSE;
		}
		ReadFile(hFile, cfg->bottom, cfg->size, &cfg->size, NULL);
		if ( memcmp(cfg->bottom, UTF8HEADER, UTF8HEADERSIZE) == 0 ){ // UTF8ϊ
			WCHAR *dataW;
			DWORD sizeW;

			cfg->size -= UTF8HEADERSIZE; // UTF8HEADER 폜
			sizeW = MultiByteToWideChar(CP_UTF8, 0, cfg->bottom + UTF8HEADERSIZE, cfg->size, NULL, 0);
			dataW = HeapAlloc(GetProcessHeap(), 0, sizeW * sizeof(WCHAR));
			MultiByteToWideChar(CP_UTF8, 0, cfg->bottom + UTF8HEADERSIZE, cfg->size, dataW, sizeW);
			HeapFree(GetProcessHeap(), 0, cfg->bottom);
			cfg->size = WideCharToMultiByte(CP_ACP, 0, dataW, sizeW, NULL, 0, NULL, NULL);
			cfg->bottom = HeapAlloc(GetProcessHeap(), 0, cfg->size + CFG_MARGIN);
			WideCharToMultiByte(CP_ACP, 0, dataW, sizeW, cfg->bottom, cfg->size, NULL, NULL);
			HeapFree(GetProcessHeap(), 0, dataW);
		}
#endif
		CloseHandle(hFile);
	}
	memset((char *)(TCHAR *)(cfg->bottom + cfg->size), 0, CFG_MARGIN * sizeof(TCHAR));
	return TRUE;
}
//------------------------------------- `t@CŐV̏ԂɍXV
BOOL CFGUpdate(CFG *cfg)
{
	if ( cfg->bottom == NULL ) return FALSE;
	if ( cfg->write ){
		HANDLE hfile;
		DWORD tmp;

		hfile = CreateFile(cfg->filename, GENERIC_WRITE, FILE_SHARE_WRITE,
				NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
		if ( hfile != INVALID_HANDLE_VALUE ){
#ifdef UNICODE
			DWORD sizeA;
			char *dataA;

			sizeA = WideCharToMultiByte(CP_UTF8, 0, cfg->bottom, -1, NULL, 0, NULL, NULL);
			dataA = HeapAlloc(GetProcessHeap(), 0, sizeA);
			if ( dataA != NULL ){
				sizeA = WideCharToMultiByte(CP_UTF8, 0, cfg->bottom, -1, dataA, sizeA, NULL, NULL) - 1;
				WriteFile(hfile, UTF8HEADER, UTF8HEADERSIZE, &tmp, NULL);
				WriteFile(hfile, dataA, sizeA, &tmp, NULL);
				HeapFree(GetProcessHeap(), 0, dataA);
			}
#else
			WriteFile(hfile, cfg->bottom, cfg->size, &tmp, NULL);
#endif
			CloseHandle(hfile);
		}
		cfg->write = 0;
	}
	return TRUE;
}
//------------------------------------- `t@C
BOOL CFGClose(CFG *cfg)
{
	if ( cfg->bottom == NULL ) return FALSE;
	CFGUpdate(cfg);
	HeapFree(GetProcessHeap(), 0, cfg->bottom);
	return TRUE;
}
/*-------------------------------------
	w offset Asǂݍ
	string ɏށB
	offset ɂ͎̍s̐擪
-------------------------------------*/
BOOL CFGGetLine(CFG *cfg, DWORD *offset, TCHAR *string, DWORD maxlength)
{
	const TCHAR *bottom, *p, *end = NULL, *strmax;

	if ( cfg->bottom == NULL ) return FALSE;
	bottom = cfg->bottom + *offset;
	if ( *bottom == '\0' ) return FALSE;
											// 擪̋󔒂폜 ---------------
	while ( *bottom == ' ' ) bottom++;
	SkipSpace(&bottom);
	p = bottom;
											// s&Rǧ ------------
	for ( ; *p ; p++ ){
		if ( *p == ';' ){
			if ( (*(p + 1) != ';') && !end ){		// Rg
				end = p;
				continue;
			}else{
				p++;
			}
		}
		if ( (*p == '\r') || (*p == '\n') ){	// CR/LF
			if ( !end ) end = p;
			p++;
			while ( (*p == '\r') || (*p == '\n') ) p++;
			break;
		}
	}
	*offset = (DWORD)(p - cfg->bottom);
	if ( end == NULL ) end = p;
											// s̋󔒂폜 ---------------
	while ( (end > bottom) && (*(end - 1) == ' ') )	end--;
											//  & TAB  ----------------
	strmax = string + maxlength - 1;
	for ( ; bottom < end ; bottom++ ){
		if ( *bottom == '\t' ) continue;
		if ( *bottom == ';' ) bottom++;
		*string++ = *bottom;
		if ( string >= strmax ) break;
	}
	*string = '\0';
	return TRUE;
}
//------------------------------------- key sǂݍ݁A擪𓾂
TCHAR *CFGFindKey(CFG *cfg, const TCHAR *key, TCHAR *string, DWORD maxlength)
{
	DWORD off = 0;
	size_t keylen;
	TCHAR *p;

	keylen = tstrlen(key);
	for(;;){
		if ( CFGGetLine(cfg, &off, string, maxlength) == FALSE ){
			p = NULL;
			break;
		}
		if ( memcmp(string, key, TSTROFF(keylen)) ) continue; // key vH
		p = string + keylen;
		SkipSpaceNC(&p);
		if ( *p != '=' ) continue;
		p++;	// '='
		SkipSpaceNC(&p);
		break;
	}
	return p;
}
//------------------------------------- p[^𒊏o
TCHAR *CFGFixParam(TCHAR *string, TCHAR **next)
{
	TCHAR *p;
	TCHAR *q;
							// 擪̋󔒂
	SkipSpaceNC(&string);
	if ( *string == '\"' ){
		string++;
		q = string;
		for(;;){
			p = tstrchr( q, '\"' );
			if ( p == NULL ){
				p = q + tstrlen( q );
				break;
			}
			if ( (*(p + 1) != ',') && ((BYTE)*(p + 1) >= ' ') ){
				q = p + 1;
				continue;
			}
			*p = '\0';
			p++;
			if ( *p == ',' ) p++;	// ̍ڂ̓o
			break;
		};
	}else{
							// ڋ؂
		p = string;
		while ( *p && (*p != ',') ) p++;
		q = p;
		if ( *p == ',' ) p++;	// ̍ڂ̓o
							// ̋󔒂
		while ( (q > string) && (*(q - 1) == ' ') ) q--;
		*q = '\0';
	}
	if ( next ) *next = p;
	return string;
}
/*-------------------------------------
	w offset Astring s
	Ƃď
	offset ɂ͎̍s̐擪
-------------------------------------*/
BOOL CFGReplaceLine(CFG *cfg, DWORD *offset, const TCHAR *key, TCHAR *string)
{
	DWORD dest, oldlen;
	size_t newlen;
	size_t keylen = 0;
	TCHAR buf[0x1000];

	dest = offset ? *offset : 0;
										// key ȂA̍s -------
	if ( key != NULL ){
		DWORD dest2;

		keylen = tstrlen(key);
		dest2 = dest;
		for(;;){
			TCHAR *p;

			dest = dest2;
			if ( CFGGetLine(cfg, &dest2, buf, TSIZEOF(buf)) == FALSE ){
				dest = cfg->size;
				break;
			}
			if ( memcmp(buf, key, TSTROFF(keylen)) ) continue; // key vH
			p = buf + keylen;
			while ( *p == ' ' ) p++;
			if ( *p != '=' ) continue;
			break;
		}
	}
										// EOF OɉsȂȂt -------
	if ( dest >= cfg->size ){
		if ( cfg->size && (*(cfg->bottom + cfg->size - 1) != '\n') ){
			*(cfg->bottom + cfg->size) = '\r';
			*(cfg->bottom + cfg->size + 1) = '\n';
			cfg->size += 2;
		}
		dest = cfg->size;
	}
										// O̍s̒߂ -----------
	oldlen = dest;
	if ( CFGGetLine(cfg, &oldlen, buf, TSIZEOF(buf)) == FALSE ) oldlen = cfg->size;
	oldlen -= dest;
										// Ċm ---------------------
	newlen = keylen + tstrlen(string) + (keylen ? 5 : 2); // " = " + CRLF
	cfg->size = (DWORD)(cfg->size - oldlen + newlen);
	if ( oldlen < newlen ){
		TCHAR *p;

		p = HeapReAlloc( GetProcessHeap(), 0, cfg->bottom, (cfg->size + CFG_MARGIN) * sizeof(TCHAR));
		if ( p == NULL ){
			MessageA("AllocError!");
		}else{
			cfg->bottom = p;
		}
	}									// ̈m ---------------------------
	if ( oldlen != newlen ){
		memmove(cfg->bottom + dest + newlen,
				cfg->bottom + dest + oldlen,
				TSTROFF(cfg->size - dest - newlen));
	}
										// ꊷ ---------------------------
	if ( keylen != 0 ){
		memcpy(cfg->bottom + dest, key,  TSTROFF(keylen));
		memcpy(cfg->bottom + dest + keylen, T("\t= "), TSTROFF(3));
		memcpy(cfg->bottom + dest + keylen + 3, string, TSTROFF(newlen - keylen - 5));
	}else{
		memcpy(cfg->bottom + dest, string, TSTROFF(newlen - 2));
	}
	*(cfg->bottom + dest + newlen - 2) = '\r';
	*(cfg->bottom + dest + newlen - 1) = '\n';
	*(cfg->bottom + cfg->size) = 0;
	cfg->write = 1;
	if ( offset ) *offset = (DWORD)(dest + newlen);
	return TRUE;
}
