/*-----------------------------------------------------------------------------
	ClockPod / ANVs										(c)TORO
-----------------------------------------------------------------------------*/
#define STRICT
#include <windows.h>
#include "CLOCKPOD.H"
#include "CALC.H"

//==================================================================== 
BOOL tPlaySoundMain(LPCTSTR wave, UINT opt)
{
	TCHAR name[MAX_PATH];
	BOOL result;

	if ( (wave == NULL) || (*wave == '\0') ){	// 
		sndPlaySound(NULL, SND_SYNC);
		if ( ChangingVolume != FALSE ){
			waveOutSetVolume(0, OldVolume);
			ChangingVolume = FALSE;
			return TRUE;
		}
	}

	if ( ResH == NULL ){	// t@C
		if ( X_VoiceDir != 0 ){
			CatPath(name, ThTOFFSETSTR(&cfgstr, X_VoiceDir), wave);
			wave = name;
		}
	}else{					// \[X
		wave = LockResource(LoadResource(ResH,
				FindResourceEx(ResH, ThTOFFSETSTR(&cfgstr, X_VoiceResID), wave,
				MAKELANGID(LANG_NEUTRAL, SUBLANG_DEFAULT))));
		opt |= SND_MEMORY;
	}
									// ʒ܂ĂȂs
	if ( (X_Volume != VRate) && (ChangingVolume == FALSE) ){
		waveOutGetVolume(0, &OldVolume);
		waveOutSetVolume(0,
				( LOWORD(OldVolume) * X_Volume / VRate ) +
				((HIWORD(OldVolume) * X_Volume / VRate ) << 16 ));
		if ( opt & SND_ASYNC ) ChangingVolume = TRUE;
	}
									// ^`FbN
	SetLastError(NO_ERROR);
	result = sndPlaySound(wave, opt | SND_NODEFAULT);
	if ( (result == FALSE) && (GetLastError() != NO_ERROR) ){
		result = TRUE;	// ʂ̃G[́AƂ݂Ȃ
	}
									// Ȃ特ʂɖ߂
	if ( !(opt & SND_ASYNC) && (X_Volume != VRate) ){
		waveOutSetVolume(0, OldVolume);
		ChangingVolume = FALSE;
	}
	return result;
}
//------------------------------------- sndPlaySound ̑҂sΉ
BOOL tPlaySound(LPCTSTR wave, UINT opt)
{
	if ( (wave == NULL) || (*wave == '\0') ){
		tPlaySoundMain(NULL, SND_SYNC);
		WaveStacks = 0;
		return TRUE;
	}
	if ( !(opt & SND_ASYNC) ){
		tPlaySoundMain(wave, opt | SND_NODEFAULT);
		return TRUE;
	}

	if ( WaveStacks >= MaxMes ) return FALSE;

	WaveStack[WaveStacks].name = wave;
	WaveStack[WaveStacks].flag = opt | SND_ASYNC | SND_NODEFAULT | SND_NOSTOP;
	WaveStacks++;
	return TRUE;
}
//============================================================== bZ[WM
//------------------------------------- ClockPod փbZ[W𑗐M
void SendPodSlot(const TCHAR *dest, const TCHAR *message)
{
	HANDLE hFile;
	DWORD size;
	TCHAR buf[MESLEN + MAX_PATH];

	wsprintf(buf, T("\\\\%s") T(MailSlotName), dest);
	hFile = CreateFile(buf, GENERIC_WRITE,
		FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if ( hFile != INVALID_HANDLE_VALUE ){
		#ifdef UNICODE
			char messageA[MESLEN * 2 + UTF8HEADERSIZE];
			memcpy(messageA, UTF8HEADER, UTF8HEADERSIZE);
			size = UnicodeToUtf8(message, messageA + UTF8HEADERSIZE, MESLEN * 2);
			WriteFile(hFile, messageA, size + UTF8HEADERSIZE, &size, NULL);
		#else
			WriteFile(hFile, message, (DWORD)tstrlen(message) + 1, &size, NULL);
		#endif
		CloseHandle(hFile);
	}
}
/*-------------------------------------
	messenger փbZ[W𑗐M

	dest:M̖OB"*"g邪Adl𖞂ĂȂ悤
		 (SȖOɂKv肻)
	message:Me
-------------------------------------*/
void SendMessenger(const TCHAR *dest, const TCHAR *message)
{
	HANDLE hFile;
	DWORD size;
	TCHAR buf[0x800];

	wsprintf(buf, T("\\\\%s\\mailslot\\messngr"), dest);
	hFile = CreateFile( buf, GENERIC_WRITE,
		FILE_SHARE_READ, NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if ( hFile != INVALID_HANDLE_VALUE ){
											// M҂̖O
		size = MAX_COMPUTERNAME_LENGTH + 1;
		GetComputerName(buf, &size);
		size++;
											// M̖O
		tstrcpy(buf + size, dest);
		size += (DWORD)tstrlen(buf + size) + 1;
											// Me
		tstrcpy(buf + size, message);
		size += (DWORD)tstrlen(buf + size) + 1;

		#ifdef UNICODE
		{
			char bufA[0x800];

			size = UnicodeToAnsi(buf, bufA, 0x800);
			WriteFile(hFile, buf, size, &size, NULL);
		}
		#else
			WriteFile(hFile, buf, size, &size, NULL);
		#endif
		CloseHandle(hFile);
	}
}
//====================================================================== ̑
//------------------------------------- ݎ\ł`ɕϊ
void SetTime(void)
{
	static TCHAR OldStime[MAXLINE][MAXLINEWIDTH];
	static int oldoffset = 0;
	static BOOL modify = FALSE;
	int offset = 0, len, maxlen = 0, line;

	if ( DispMesStock ) offset = X_telopx;
	if ( oldoffset != offset ){
		oldoffset = offset;
		modify = TRUE;
	}

	// 𐶐
	for ( line = 0 ; line < textlines ; line++ ){
		timelen[line] = len = (int)(tsprintf(timetext[line], S_format[line], NULL) - timetext[line]);
		if ( maxlen < len ) maxlen = len;
		if ( memcmp(OldStime[line], timetext[line], TSTROFF(len + 1)) ){
			memcpy(OldStime[line], timetext[line], TSTROFF(len + 1));
			modify = TRUE;
		}
	}

	// \vZ
	// NT3.51InterlockedIncrement̓삪̂TM_DETAIL̎
	if ( ((TransparMode != TM_DETAIL) || (InterlockedIncrement(&UseMdcBitsPtr) == 1)) &&
		 ( (modify != FALSE) || (aWndLen && (OldaWndLen != aWndLen)) ) ){
		modify = FALSE;
		OldaWndLen = aWndLen;
		if ( PFont ){ // v|[VitHg
			HDC hDC;
			SIZE textsize, textsize2;
			HFONT hOldFont;
			int i;

			hDC = GetDC(hMainWnd);
			hOldFont = SelectObject(hDC, hBoxFont);

			textsize.cx = 0;
			for ( i = 0 ; i < textlines ; i++ ){
				GetTextExtentPoint32(hDC, timetext[i], timelen[i], &textsize2);
				if ( textsize.cx < textsize2.cx ){
					textsize.cx = textsize2.cx;
				}
			}
			SelectObject(hDC, hOldFont);
			ReleaseDC(hMainWnd, hDC);
			WindowSize.cx = textsize.cx + offset * FontSize.x;
		}else{ // tHg
			WindowSize.cx = FontSize.x * (maxlen + offset);
		}
		WindowSize.cy = FontSize.y * textlines;
		if ( hMdc != NULL ){
			int y;

			y = WindowSize.cy;
			if ( X_telopl < 0 ) y += FontSize.y; // \߂Ps]ɂĂ

			if ( TransparMode == TM_DETAIL ){
				BITMAPINFOHEADER bi;
				HBITMAP hMemBmp;
				BYTE *BitsPtr;

				memset(&bi, 0, sizeof(BITMAPINFOHEADER));
				bi.biSize = sizeof(BITMAPINFOHEADER);
				bi.biWidth = WindowSize.cx;
				bi.biHeight = y;
				bi.biPlanes = 1;
				bi.biBitCount = 32;

				hMemBmp = CreateDIBSection(hMdc, (BITMAPINFO *)&bi, DIB_RGB_COLORS, (void **)&BitsPtr, NULL, 0);
				if ( hMemBmp != NULL ){
					if ( (BitsPtr == NULL) || IsBadReadPtr(BitsPtr + bi.biWidth * bi.biHeight * 4 - 4, 1) ){
						SetMessage(zNoID, T("SetTime MdcBitsPtr BadAlloc"), DMES_LOGTELOP, NULL);
					}else{
						MdcBitsPtr = BitsPtr;
						MdcBitsSize.cx = bi.biWidth;
						MdcBitsSize.cy = bi.biHeight;
						DeleteObject(SelectObject(hMdc, hMemBmp));
					}
				}
			}else{
				MdcBitsPtr = NULL;
				DeleteObject(SelectObject(hMdc,
					CreateCompatibleBitmap(hMdc, WindowSize.cx, y)));
			}
		}
		// ebv̂ݍs𑝂₷Ƃ
		if ( DispMesStock && (X_telopl < 0) ) WindowSize.cy += FontSize.y;
		DrawWindow(hMainWnd);
		MoveClock(hMainWnd);
	}
	if ( TransparMode == TM_DETAIL ) InterlockedDecrement(&UseMdcBitsPtr);
}
//------------------------------------- \̑傫
void ResetTime(void)
{
	OldaWndLen = 0;
	GetLocalTime(&ltime);
	SetTime();
}
//------------------------------------- tick ̌oߎԂZo
DWORD GetPassSec(DWORD tick)
{
	tick -= TimerNowTick;
	if ( tick >= 0x80000000 ) tick = 0 - tick;
	return tick / 1000 + 1;
}
//============================================================= ExecAction 
//------------------------------------- AC_interval ̃C
BOOL CheckInterval(INTERVALS *in)
{
	int i;
	DWORD interval;

	interval = in->interval;
	if ( in->useRAS ) for ( i = 0 ; i < MAXRAS ; i++ ){
		if ( !ConnectionList[i].rasname[0] ) continue;
		if ( !tstrcmp(ThTOFFSETSTR(&cfgstr, in->useRAS), ConnectionList[i].rasname) ){
			interval = in->RASinterval;
			break;
		}
	}
	if ( interval && (GetPassSec(in->lasttick) >= interval) ){
		in->lasttick = TimerNowTick;
		return TRUE;
	}
	return FALSE;
}
//------------------------------------- AC_delete ̃C
BOOL ACdeleteMain(int id)
{
	int i;

	for ( i = 0 ; i < DispMesStock ; i++ ){
		if ( id == DMessage[i].id ){
			DeleteTelop(i);
			return TRUE;
		}
	}
	return FALSE;
}
#define ThenAc(sname) (ACTIONS *)(cfgac.bottom + ((sname *)ac)->ac.thenac)
#define ElseAc(sname) (ACTIONS *)(cfgac.bottom + ((sname *)ac)->ac.elseac)

#define BranchAc(sname, boolvalue) (ACTIONS *)(cfgac.bottom + ((boolvalue) ? ((sname *)ac)->ac.thenac : ((sname *)ac)->ac.elseac))

//------------------------------------- w肳ꂽ ac s
BOOL ExecAction(ACTIONS *ac, int id, const TCHAR *param)
{
	TCHAR buf[0x800], str2[0x400];

	if ( param == NULL ) param = T("");

	while ( ac != NULL ){
	  if ( ac == (ACTIONS *)cfgac.bottom ) break; // Ȃ
	  switch ( ac->type ){
		case AC_break:		// Break
			return FALSE;

		case AC_message:	// Message
			SetMessage(id, ThTOFFSETSTR(&cfgstr, ((AC_MESSAGE *)ac)->message),
					  ((AC_MESSAGE *)ac)->flag, param);
			break;

		case AC_color: // Color
			C_use = ((AC_COLOR *)ac)->color;
			DrawWindow(hMainWnd);
			break;

		case AC_wave: // Wave
			tPlaySound(ThTOFFSETSTR(&cfgstr, ((AC_WAVE *)ac)->wave),
				((((AC_WAVE *)ac)->flag & ACWAV_FORCE) ? SND_SYNC : SND_ASYNC) |
				((((AC_WAVE *)ac)->flag & ACWAV_LOOP) ? SND_LOOP : 0));
			break;

		case AC_exec:{ //Exec
			STARTUPINFO			si;
			PROCESS_INFORMATION pi;
			TCHAR *p;

			si.cb			= sizeof(si);
			si.lpReserved	= NULL;
			si.lpDesktop	= NULL;
			si.lpTitle		= NULL;
			si.dwFlags		= 0;
			si.cbReserved2	= 0;
			si.lpReserved2	= NULL;

			p = ThTOFFSETSTR(&cfgstr, ((AC_EXEC *)ac)->cmd);
			if ( *p == '/' ){
				p++;
				if ( *p == 'N' ){
					p++;
					si.dwFlags = STARTF_USESHOWWINDOW;
					si.wShowWindow = SW_SHOWMINIMIZED;
				}
				if ( *p == 'X' ){
					p++;
					si.dwFlags = STARTF_USESHOWWINDOW;
					si.wShowWindow = SW_SHOWMAXIMIZED;
				}
			}
			tsprintf(buf, p, param);

			if ( CreateProcess(NULL, buf, NULL, NULL, FALSE,
				CREATE_DEFAULT_ERROR_MODE, NULL, NULL, &si, &pi) ){
				CloseHandle(pi.hProcess);
				CloseHandle(pi.hThread);
			}else{
				Z_ExecAction(zError, T("1+exec"));
			}
			break;
		}
		case AC_compare:{ //Compare
			TCHAR *str1, *str2p;

			tsprintf(buf, ThTOFFSETSTR(&cfgstr, ((AC_COMPARE *)ac)->str1), param);
			str1 = buf;
			SkipSpaceNC(&str1);
			SkipSpaceB(str1, str1 + tstrlen(str1));
			str2p = ThTOFFSETSTR(&cfgstr, ((AC_COMPARE *)ac)->str2);

			if ( !*str2p ){		// dest 
				if ( ExecAction(BranchAc(AC_COMPARE, *str1), id, param) == FALSE ){
					return FALSE;
				}
			}else{
				while (*str2p){
					tsprintf(str2, str2p, param);
					if ( !tstricmp(str1, str2) ){
						if ( ExecAction(ThenAc(AC_COMPARE), id, param) == FALSE ){
							return FALSE;
						}
						break;
					}
					str2p += tstrlen(str2p) + 1;
				}
				if ( !*str2p ){
					if ( ExecAction(ElseAc(AC_COMPARE), id, param) == FALSE ){
						return FALSE;
					}
				}
			}
			break;
		}
		case AC_find:{ //Find
			TCHAR *str2p;

			tsprintf(buf, ThTOFFSETSTR(&cfgstr, ((AC_COMPARE *)ac)->str1), param);
			str2p = ThTOFFSETSTR(&cfgstr, ((AC_COMPARE *)ac)->str2);

			while ( *str2p != '\0' ){
				tsprintf(str2, str2p, param);
				if ( tstrstr(buf, str2) ){
					if ( ExecAction(ThenAc(AC_COMPARE), id, param) == FALSE ){
						return FALSE;
					}
					break;
				}
				str2p += tstrlen(str2p) + 1;
			}
			if ( !*str2p ){
				if ( FALSE == ExecAction(ElseAc(AC_COMPARE), id, param) ){
					return FALSE;
				}
			}
			break;
		}
		case AC_if:{ // If
			const TCHAR *p;
			int num;

			tsprintf(buf, ThTOFFSETSTR(&cfgstr, ((AC_IF *)ac)->form), param);
			p = buf;
			CalcString(&p, &num);

			if ( FALSE == ExecAction(BranchAc(AC_IF, num), id, param) ){
				return FALSE;
			}
			break;
		}

		case AC_interval: // interval
			if ( FALSE == ExecAction(BranchAc(AC_INTERVAL,
					CheckInterval(&((AC_INTERVAL *)ac)->i) ), id, param) ){
				return FALSE;
			}
			break;

		case AC_mailchk: { // mail check
			TCHAR *p, *account;

			p = ThTOFFSETSTR(&cfgstr, ((AC_MAILCHK *)ac)->account);
			if ( *p != '\0' ){
				while ( *p != '\0' ){
					int lid;
					ACOFF offset;
					AC_MAIL *acm;

					tsprintf(buf, p, param);
					account = buf;
					SkipSpaceNC(&account);
					SkipSpaceB(account, account + tstrlen(account));
					lid = 0;
					for (offset = AC_mails ; offset ; offset = acm->next, lid++){
						acm = (AC_MAIL *)(cfgac.bottom + offset);
						if ( !tstrcmp(account, ThTOFFSETSTR(&cfgstr, acm->id)) ){
							StartMailCheck(((AC_MAILCHK *)ac)->flag, lid);
							break;
						}
					}
					p += tstrlen(p) + 1;
				}
			}else{
				StartMailCheck(((AC_MAILCHK *)ac)->flag, -1);
			}
			break;
		}
		case AC_value: // set value
			tsprintf(buf, ThTOFFSETSTR(&cfgstr, ((AC_VALUE *)ac)->param), param);
			SetEnvironmentVariable(ThTOFFSETSTR(&cfgstr, ((AC_VALUE *)ac)->name), buf);
			break;

		case AC_cvalue: { // set calculated value
			const TCHAR *p;
			int num;

			tsprintf(buf, ThTOFFSETSTR(&cfgstr, ((AC_VALUE *)ac)->param), param);
			p = buf;
			CalcString(&p, &num);
			wsprintf(buf, T("%d"), num);
			SetEnvironmentVariable(ThTOFFSETSTR(&cfgstr, ((AC_VALUE *)ac)->name), buf);
			break;
		}

		case AC_delete:
			tsprintf(buf, ThTOFFSETSTR(&cfgstr, ((AC_DELETE *)ac)->type), param);
									// p[^ŐV̂P폜
			if ( buf[0] == '\0' ){
				DeleteTelop(0);
				break;
			}
			{						// [
				ACOFF offset;
				AC_MAIL *acm;

				for ( offset = AC_mails ; offset ; offset = acm->next ){
					acm = (AC_MAIL *)(cfgac.bottom + offset);
					if ( !tstrcmp(ThTOFFSETSTR(&cfgstr, acm->id), buf) ){
						if ( ACdeleteMain((int)(AC_MAIL *)acm) != FALSE ) break;
					}
				}
				if ( offset != 0 ) break;
			}
			{						// Z_xxxx 
				int lid;
				for ( lid = 0 ; lid < MESS ; lid++ ){
					if ( !tstrcmp(CustMes[lid], buf) ){
						if ( ACdeleteMain(lid) != FALSE ) break;
					}
				}
			}
			break;

		case AC_close:		// close
			PostMessage(ahWnd, WM_CLOSE, 0, 0);
			break;

		case AC_pointinfo: {	// pointinfo
			POINT pos;
			HWND phWnd;

			GetMessagePosPoint(pos);
			phWnd = GetWindowFromPoint(pos);
			if ( phWnd != NULL ) WindowRupt(hMainWnd, phWnd, &pos);
			break;
		}
	  }

	  if ( !ac->next ) break;
	  ac = (ACTIONS *)(cfgac.bottom + ac->next);
	}
	return TRUE;
}
