/*-----------------------------------------------------------------------------
	ClockPod / JX^}CYǍ									(c)TORO
-----------------------------------------------------------------------------*/
#define STRICT
#include <windows.h>
#include "CLOCKPOD.H"
//==================================================================== e`
#define CFG_COMPANY "TOROID"		// AppData ̒Ɏgp閼O
#define CFG_APPNAME "ClockPod"		// CFG_COMPANY ̉Ɏgp閼O

typedef struct {
	TCHAR *str;	//	x
	int num;	//	l
} LABEL;
			// {"v", C_v} `ɕϊ
#define color_count 21
#define REGCLR(v)	{T(#v), C_ ## v}
static const LABEL color[color_count] = {
	REGCLR(BLACK),	REGCLR(BLUE),	REGCLR(RED),	REGCLR(MAGENTA),
	REGCLR(GREEN),	REGCLR(CYAN),	REGCLR(YELLOW),	REGCLR(WHITE),

	REGCLR(DBLACK),	REGCLR(DBLUE),	REGCLR(DRED),	REGCLR(DMAGENTA),
	REGCLR(DGREEN),	REGCLR(DCYAN),	REGCLR(DYELLOW), REGCLR(DWHITE),

	REGCLR(MGREEN),	REGCLR(SBLUE),	REGCLR(CREAM),	REGCLR(GRAY),
	REGCLR(AUTO)
};

void GetAction(CFG *cfg, ACOFF *ac, DWORD *offset, int level);
void GetBranchAction(CFG *cfg, BACOFF *ac, DWORD *offset, int level);

#define ThAddCfgstr(param) ThAddString(&cfgstr, param)
#define ThAddActions(ac) ThAppend(&cfgac, &ac, sizeof(ac))

STROFF USEFASTCALL ThAddCfgstrParam(LPTSTR *param)
{
	return ThAddString(&cfgstr, CFGFixParam(*param, param));
}
#ifdef UNICODE
	STROFFA USEFASTCALL ThAddCfgstrParamA(LPTSTR *param)
	{
		TCHAR *paramW;
		char bufA[0x400];
		DWORD sizeA;

		paramW = CFGFixParam(*param, param);
		sizeA = (UnicodeToUtf8(paramW, bufA, 0x400) + 1) & 0xfffffffe;
		return ThAppend(&cfgstr, bufA, sizeA);
	}

	STROFFA USEFASTCALL ThAddCfgstrParamA2(LPTSTR *param)
	{
		TCHAR *paramW;
		char bufA[0x400];
		DWORD sizeA;

		paramW = CFGFixParam(*param, param);
		sizeA = UnicodeToUtf8(paramW, bufA, 0x400);
		return ThAppend(&cfgstr, bufA, sizeA);
	}

	STROFFA USEFASTCALL ThAddCfgstrA(LPCTSTR param)
	{
		char bufA[0x400];
		DWORD sizeA;

		sizeA = (UnicodeToUtf8(param, bufA, 0x400) + 1) & 0xfffffffe;
		return ThAppend(&cfgstr, bufA, sizeA);
	}
/*
	STROFF USEFASTCALL ThAddStringA(ThSTRUCT *TH, const char *data)
	{
		DWORD sizeA;

		sizeA = (strlen(data) + 1) & 0xfffffffe;
		return ThAppend(TH, data, sizeA);
	}
*/
#else
	#define ThAddCfgstrParamA(param) ThAddCfgstrParam(param)
	#define ThAddCfgstrParamA2(param) ThAddCfgstrParam(param)
	#define ThAddCfgstrA(param) ThAddCfgstr(param)
#endif
//====================================================================== ̑
//------------------------------------- s󔒂(b:擪, p:)
void USEFASTCALL SkipSpaceB(TCHAR *b, TCHAR *p)
{
#ifdef DEBUG
	if ( b == p ){
		*p = '\0';
		return;
	}
#endif
	p--;

	while( b < p ){
		if ( (*p == ' ') || (*p == '\t') ){
			p--;
			continue;
		}
		break;
	}
	*(p + 1) = '\0';
}
//------------------------------------- l𓾂B͎ŝƂ -1
int USEFASTCALL GetNumber(LPCTSTR *ptr)
{
	TCHAR data;
	const TCHAR *p;
	int num = 0, minus = 0;

	p = *ptr;
	SkipSpace(&p);
	if ( *p == '-' ){
		minus = 1;
		p++;
	}
	switch( data = *p++ ){;
										/*	2 ȉ --------------------*/
		case 'b':
		case 'B':
			while( (UTCHAR)(data = (TCHAR)(*p - '0')) < 2 ){
				p++;
				num = (num << 1) + data;
			}
			break;
										/*	16 ȉ -------------------*/
		case 'h':
		case 'H':
			while( Isxdigit( data = upper(*p)) ){
				p++;
				if ( (data = (char)(data - '0')) > 9 )	data = (char)(data - 7);
				num = (num << 4) + data;
			}
			break;
										/*	萔̏ ------------------*/
		case '\'':
			num = *p;
			p += 2;
			break;

		default:
			if ( Isdigit(data) ){
										/*	10 ȉ -------------------*/
				num = data - '0';			/* P */
				while( Isdigit( data = *p) ){
					p++;
					num = num * 10 + (data - '0');
				}
			}else{
				num = -1;
			}
	}
	*ptr = p;
	if ( (num >= 0) && minus ) num = -num;
	return num;
}
//------------------------------------- ꕶIvV͂Arbg
#define GetFlagsNC(p, flags) GetFlags((LPCTSTR *)p, flags)
DWORD USEFASTCALL GetFlags(LPCTSTR *p, const TCHAR *flags)
{
	DWORD flag = 0;
	int i;

	while( **p ){
		SkipSpace(p);
		if ( **p == ',' ){
			(*p)++;
			break;
		}
		for ( i = 0 ; flags[i] ; i++ ){
			if ( flags[i] == **p ){
				flag |= (1 << i);
				break;
			}
		}
		(*p)++;
	}
	return flag;
}
//------------------------------------- "color" ̊e
COLORREF USEFASTCALL GetColor(TCHAR **param)
{
	int i;
	const TCHAR *p;

	p = CFGFixParam(*param, param);
										// `ςݎʎq𔻕
	for ( i = 0 ; i < color_count ; i++ ){
		if ( !tstricmp(p, color[i].str) ) return color[i].num;
	}
	return (COLORREF)GetNumber(&p);
}
//------------------------------------- "color" {
void USEFASTCALL GetColors(TCHAR *param, COLORS *c)
{
	c->fg = GetColor(&param);
	c->bg = GetColor(&param);
}
//------------------------------------- "interval" {
void USEFASTCALL GetInterval(TCHAR **param, INTERVALS *i)
{
	const TCHAR *p;

	i->lasttick = GetTickCount();
	p = CFGFixParam(*param, param);
	i->interval = GetNumber(&p);
	p = CFGFixParam(*param, param);
	i->RASinterval = GetNumber(&p);
	i->useRAS = ThAddCfgstrParam(param);
}
//================================================== eANV̌ʐݒ擾
void AddChain(ACOFF *base, ACOFF aco)
{
	ACOFF offset;

	offset = *base;
	if ( offset != 0 ){
		ACTIONS *acp;

		for ( ; offset != 0 ; offset = acp->next ){
			acp = (ACTIONS *)(cfgac.bottom + offset);
		}
		acp->next = aco;
	}else{
		*base = aco;
	}
}
//------------------------------------- "POP3"/"APOP"/"IMAP"
int SetMails(CFG *cfg, TCHAR *param, int flags, DWORD *offset)
{
	AC_MAIL mail;
	int write = 0;
	const TCHAR *p;
	char PassBufA[0x100];
#ifdef UNICODE
	WCHAR PassBufW[0x100];
#endif
												// Name
	mail.id = ThAddCfgstrParam(&param);
												// Flags
	mail.flags = GetFlagsNC(&param, ACMAIL_FLAGS) | flags;
												// IP
	mail.ip = ThAddCfgstrParamA(&param);
												// port
	p = CFGFixParam(param, &param);
	mail.port = GetNumberNC(&p);
												// user
	mail.user = ThAddCfgstrParamA(&param);
												// password
	p = CFGFixParam(param, &param);
	if ( (*p == '`') && (*(p + 1) == '`') ){	// password 
		p += 2;
		MaskingBinary(PassBufA, ReadHex(&p, PassBufA, sizeof(PassBufA)));
#ifdef UNICODE
		AnsiToUnicode(PassBufA, PassBufW, 0x100);
		p = PassBufW;
#else
		p = PassBufA;
#endif
	}else{
		write = 1;
	}
	mail.pwd = ThAddCfgstrA(p);
												// interval(time1, time2, ras)
	GetInterval(&param, &mail.i);
												// mailbox
	mail.mailbox = ThAddCfgstrParamA(&param);

	mail.next = 0;
	mail.check = FALSE;
	mail.allcount = mail.unseen = 0;
	mail.spams = 0;
	mail.last.wHour = 0;
	mail.last.wMinute = 0;
	mail.i.interval *= 60;
	mail.i.RASinterval *= 60;
	mail.i.lasttick -= 24 * 60 * 60 * 1000; // 
	ThInit(&mail.list);
											// `FCɓo^
	AddChain(&AC_mails, ThAddActions(mail));
											// ǉ
	if ( write ){
		TCHAR buf[0x400], pass[0x400], flagsstr[] = ACMAIL_FLAGS, *name;
		int i;

		for ( i = 0 ; i < 4 ; i++ ){
			if ( !(mail.flags & (1 << i)) ) flagsstr[i] = ' ';
		}
		strcpy((char *)buf, cfgstr.bottom + mail.pwd);
		i = (int)(strlen((char *)buf) + 1 + 8) & ~(8 - 1);
		MaskingBinary((char *)buf, i);
		WriteHex(pass, (char *)buf, i);

		name = T("POP3");
		if ( mail.flags & ACMAIL_USEAPOP ){
			name = T("APOP");
		}else if ( mail.flags & ACMAIL_USEIMAP ){
			name = T("IMAP4");
		}
#ifdef UNICODE
		{
			WCHAR ipW[0x100], userW[0x100], mailboxW[0x100];

			AnsiToUnicode(cfgstr.bottom + mail.ip, ipW, 0x100);
			AnsiToUnicode(cfgstr.bottom + mail.user, userW, 0x100);
			AnsiToUnicode(cfgstr.bottom + mail.mailbox, mailboxW, 0x100);

			wsprintf(buf, L"%s\t= %s,%s,%s,%d,\"%s\",``%s,%d,%d,%s,%s",
					name,
					(WCHAR *)(char *)(cfgstr.bottom + mail.id),
					flagsstr,
					ipW,
					mail.port,
					userW,
					pass,
					mail.i.interval / 60,
					mail.i.RASinterval / 60,
					ThTOFFSETSTR(&cfgstr, mail.i.useRAS),
					mailboxW);
		}
#else
		wsprintf(buf, "%s\t= %s,%s,%s,%d,\"%s\",``%s,%d,%d,%s,%s",
				name,
				cfgstr.bottom + mail.id,
				flagsstr,
				cfgstr.bottom + mail.ip,
				mail.port,
				cfgstr.bottom + mail.user,
				pass,
				mail.i.interval / 60,
				mail.i.RASinterval / 60,
				ThTOFFSETSTR(&cfgstr, mail.i.useRAS),
				cfgstr.bottom + mail.mailbox);
#endif
		CFGReplaceLine(cfg, offset, NULL, buf);
		return 1;
	}
	return 0;
}
//------------------------------------- "spam"
void SetMailfilter(TCHAR *param)
{
	AC_SPAM spam;
	const TCHAR *p;

	spam.next = 0;
												// Name
	spam.id = ThAddCfgstrParamA(&param);
												// point
	p = CFGFixParam(param, &param);
	spam.points = GetNumber(&p);
												// header
	spam.header = ThAddCfgstrParamA(&param);
												// keyword
	spam.keyword = ThAddCfgstrParamA2(&param);
	while ( *param != '\0' ) ThAddCfgstrParamA2(&param);
	#ifdef UNICODE
		ThAppend(&cfgstr, NilStr, cfgstr.size & 1 ? 1 : 2); // keyword teminater
	#else
		ThAppend(&cfgstr, NilStr, 1); // keyword teminater
	#endif
											// `FCɓo^
	AddChain(&AC_spams, ThAddActions(spam));
	return;
}
//------------------------------------- "imeon"/"imeoff"/"imeasis"
void SetIMEchange(TCHAR *param, int mode)
{
	AC_IMECHANGE imechg;

	X_IME = 2; // DLLgp
	imechg.next = 0;
	imechg.mode = mode;
	imechg.caption = ThAddCfgstrParam(&param);
	imechg.classname = ThAddCfgstrParam(&param);
											// `FCɓo^
	AddChain(&AC_ime, ThAddActions(imechg));
	return;
}
//------------------------------------- "break"
ACOFF ACGetBreak(void)
{
	ACTIONS c;

	c.next = 0;
	c.type = AC_break;
	return ThAddActions(c);
}
//------------------------------------- "message"
ACOFF ACGetMessage(TCHAR *param)
{
	AC_MESSAGE acm;

	if ( !*param) return 0;
	acm.c.next = 0;
	acm.c.type = AC_message;
	acm.flag = GetFlagsNC(&param, DMES_FLAGS);
	acm.message = ThAddCfgstrParam(&param);
	return ThAddActions(acm);
}
//------------------------------------- "color"
ACOFF ACGetColor(TCHAR *param)
{
	AC_COLOR acc;

	acc.c.next = 0;
	acc.c.type = AC_color;
	GetColors(param, &acc.color);
	return ThAddActions(acc);
}
//------------------------------------- "wave"
ACOFF ACGetWave(TCHAR *param)
{
	AC_WAVE acw;

	if ( !*param) return 0;
	acw.c.next = 0;
	acw.c.type = AC_wave;
	acw.flag = GetFlagsNC(&param, ACWAV_FLAGS);
	acw.wave = ThAddCfgstrParam(&param);
	return ThAddActions(acw);
}
//------------------------------------- "exec"
ACOFF ACGetExec(TCHAR *param)
{
	AC_EXEC ace;

	ace.c.next = 0;
	ace.c.type = AC_exec;
	ace.cmd = ThAddCfgstrParam(&param);
	return ThAddActions(ace);
}
//------------------------------------- "compare"
ACOFF ACGetCompare(CFG *cfg, TCHAR *param, DWORD *offset, int level)
{
	AC_COMPARE acc;

	acc.c.next = 0;
	acc.c.type = AC_compare;
	acc.str1 = ThAddCfgstrParam(&param);
	acc.str2 = ThAddCfgstrParam(&param);
	while ( *param ) ThAddCfgstrParam(&param);
	ThAddCfgstr(T(""));
	GetBranchAction(cfg, &acc.ac, offset, level);
	return ThAddActions(acc);
}
//------------------------------------- "if"
ACOFF ACGetIf(CFG *cfg, TCHAR *param, DWORD *offset, int level)
{
	AC_IF aci;

	aci.c.next = 0;
	aci.c.type = AC_if;
	aci.form = ThAddCfgstrParam(&param);
	GetBranchAction(cfg, &aci.ac, offset, level);
	return ThAddActions(aci);
}
//------------------------------------- "interval"
ACOFF ACGetInterval(CFG *cfg, TCHAR *param, DWORD *offset, int level)
{
	AC_INTERVAL aci;
	const TCHAR *p;
	int first;

	aci.c.next = 0;
	aci.c.type = AC_interval;

	p = CFGFixParam(param, &param);
	first = GetNumber(&p);
	GetInterval(&param, &aci.i);
	if ( first ) aci.i.lasttick -= 24 * 60 * 60 * 1000; // 
	GetBranchAction(cfg, &aci.ac, offset, level);
	return ThAddActions(aci);
}
//------------------------------------- "mailchk"
ACOFF ACGetMailchk(TCHAR *param)
{
	AC_MAILCHK acm;

	acm.c.next = 0;
	acm.c.type = AC_mailchk;
	acm.flag = GetFlagsNC(&param, ACMC_FLAGS);
	acm.account = ThAddCfgstrParam(&param);
	while ( *param != '\0' ) ThAddCfgstrParam(&param);
	ThAddCfgstr(NilStr);
	return ThAddActions(acm);
}
//------------------------------------- "delete"
ACOFF ACGetDelete(TCHAR *param)
{
	AC_DELETE acd;

	acd.c.next = 0;
	acd.c.type = AC_delete;
	acd.type = ThAddCfgstrParam(&param);
	return ThAddActions(acd);
}
//------------------------------------- "close"
ACOFF ACGetClose(void)
{
	ACTIONS c;

	c.next = 0;
	c.type = AC_close;
	return ThAddActions(c);
}
//------------------------------------- "point"
ACOFF ACGetPointInfo(void)
{
	ACTIONS c;

	c.next = 0;
	c.type = AC_pointinfo;
	return ThAddActions(c);
}
//------------------------------------- "set value"
ACOFF ACGetValue(TCHAR *name, TCHAR *param, int type)
{
	AC_VALUE acv;

	acv.c.next = 0;
	acv.c.type = type;
	acv.name   = ThAddCfgstrParam(&name);
	acv.param  = ThAddCfgstrParam(&param);
	return ThAddActions(acv);
}
//------------------------------------- wKw͈̔͂̃ANV擾
void GetAction(CFG *cfg, ACOFF *ac, DWORD *offset, int level)
{
	ACOFF acoffset, acnext = 0;
	DWORD off;
	TCHAR buf[0x1000], *p, *q;
	int i;

	*ac = 0;
	off = *offset;
	for ( ; CFGGetLine(cfg, &off, buf, TSIZEOF(buf)) ; *offset = off ){
		p = tstrchr(buf, '=');
		if( p == NULL ) continue;

		for ( i = 0 ; i < level ; i++ ) if ( buf[i] != '+' ) break;
		if ( i != level ) break;

		q = buf + i;
		SkipSpaceB(q, p);
		p++;
		SkipSpaceNC(&p);
		acoffset = 0;
		if ( !tstricmp(q, T("BREAK")) ){			acoffset = ACGetBreak();
		}else if ( !tstricmp(q, T("MESSAGE")) ){	acoffset = ACGetMessage(p);
		}else if ( !tstricmp(q, T("WAVE")) ){	acoffset = ACGetWave(p);
		}else if ( !tstricmp(q, T("COLOR")) ){	acoffset = ACGetColor(p);
		}else if ( !tstricmp(q, T("EXEC")) ){	acoffset = ACGetExec(p);
		}else if ( !tstricmp(q, T("POINT")) ){	acoffset = ACGetPointInfo();
		}else if ( !tstricmp(q, T("MAILCHK")) ){	acoffset = ACGetMailchk(p);
		}else if ( !tstricmp(q, T("DELETE")) ){	acoffset = ACGetDelete(p);
		}else if ( !tstricmp(q, T("CLOSE")) ){	acoffset = ACGetClose();
		}else if ( !tstricmp(q, T("COMPARE")) ){
			acoffset = ACGetCompare(cfg, p, &off, level);
		}else if ( !tstricmp(q, T("FIND")) ){
			acoffset = ACGetCompare(cfg, p, &off, level);
			if ( acoffset != 0 ){
				((ACTIONS *)(cfgac.bottom + acoffset))->type = AC_find;
			}
		}else if ( !tstricmp(q, T("IF")) ){
			acoffset = ACGetIf(cfg, p, &off, level);
		}else if ( !tstricmp(q, T("INTERVAL")) ){
			acoffset = ACGetInterval(cfg, p, &off, level);
		}else if ( *q == '%' ){
			if ( *(q + 1) == 'v' ){
				acoffset = ACGetValue(q + 2, p, AC_value);
			}else if ( *(q + 1) == 'c' ){
				acoffset = ACGetValue(q + 2, p, AC_cvalue);
			}
		}
		if ( acoffset == 0 ) continue;
		if ( acnext ){
			((ACTIONS *)(cfgac.bottom + acnext))->next = acoffset;
		}else{
			*ac = acoffset;
		}
		acnext = acoffset;
	}
	return;
}

void GetBranchAction(CFG *cfg, BACOFF *ac, DWORD *offset, int level)
{
	DWORD off;
	TCHAR buf[0x1000], *p, *q;
	int i;

	GetAction(cfg, &ac->thenac, offset, level + 1);
	ac->elseac = 0;
	off = *offset;
	for ( ; CFGGetLine(cfg, &off, buf, TSIZEOF(buf)) ; ){
		p = tstrchr(buf, '=');
		if( p == NULL ) continue;

		for ( i = 0 ; i < level ; i++ ) if ( buf[i] != '+' ) break;
		if ( i != level ) break;

		q = buf + i;
		SkipSpaceB(q, p);
		p++;
		SkipSpaceNC(&p);
		if ( !tstricmp(q, T("ELSE"))){
			GetAction(cfg, &ac->elseac, &off, level + 1);
			*offset = off;
		}
	}
	return;
}

//========================================================== `t@C
const TCHAR CfgName[] = T("CLOCKPOD.CFG");
const TCHAR AppDataPath[] = T("Software\\Microsoft\\Windows\\CurrentVersion\\Explorer\\Shell Folders");
const TCHAR AppDataName[] = T("AppData");

void USEFASTCALL MakeCfgFilename(TCHAR *filename, const TCHAR *param)
{
	TCHAR orgname[MAX_PATH];
	TCHAR name[MAX_PATH];
	DWORD tmp;
									// p[^Ŏw肳Ă΂g
	if ( GetLineParamNC(&param, orgname) ){
		TCHAR *ptr;

		GetFullPathName(orgname, MAX_PATH, filename, &ptr);
		return;
	}
									// 肠IWit@C쐬
	CatPath(orgname, ExePath, CfgName);
									// AppData ΂g
	while ( GetRegString(HKEY_CURRENT_USER,
			AppDataPath, AppDataName, name, sizeof(name))){
		CatPath(filename, name, T(CFG_COMPANY) T("\\") T(CFG_APPNAME));
		CatPath(NULL, filename, CfgName);
		if ( GetFileAttributes(filename) == FFD ){
			CatPath(NULL, name, T(CFG_COMPANY));
			CreateDirectory(name, NULL);
			CatPath(NULL, name, T(CFG_APPNAME));
			CreateDirectory(name, NULL);
			CopyFile(orgname, filename, TRUE);
		}
		return;
	}
	tmp = 64;
	tstrcpy(filename, orgname);
	if ( FALSE != GetUserName(name, &tmp) ){
		CatPath(filename, ExePath, name);
		tstrcat(filename, T(".CFG"));
	}
	if ( GetFileAttributes(filename) == FFD ) CopyFile(orgname, filename, TRUE);
	return;
}
//============================================================ JX^}CY{
int USEFASTCALL Customize(int mode)
{
	DWORD offset = 0, off;
	TCHAR buf[0x1000];
	TCHAR *q;
	int i;
	int coldboot = 1;
	CFG cfg;

	for ( i = 0 ; i < MAXLINE ; i++ ){
		S_format[i][0] = '\0';
		timelen[i] = 0;
	}
	textlines = 0;

	if ( CFGOpen(&cfg, cfgfile) == FALSE ) return 1;
	MailCheckBreak = MAILCHECK_OFF;
	if ( hMailThread != NULL ) WaitForSingleObject(hMailThread, 20000);

	if ( mode != 0 ){
		const TCHAR *rptr;

		rptr = CFGFindKey(&cfg, T("DPos"), buf, TSIZEOF(buf));
		if ( rptr != NULL ){
			ReadHex(&rptr, &DPosOFFS, sizeof(DPosOFFS));
		}else{
			int cxsize = GetSystemMetrics(SM_CXSIZE);
			if ( OSver.dwMajorVersion >= 10 ) cxsize += 8;
			DPosOFFS[DPOS_NORMAL].x = DPosOFFS[DPOS_MAXIMIZED].x = cxsize * -3;
		}
		rptr = CFGFindKey(&cfg, T("Font"), buf, TSIZEOF(buf));
		if ( rptr != NULL ){
			#ifdef UNICODE
				LOGFONTWITHDPIA fontA;

				fontA.dpi = 0;
				ReadHex(&rptr, &fontA, sizeof(fontA));
				memcpy(&lBoxFont.font, &fontA.font, sizeof(LOGFONTA) - LF_FACESIZE);
				AnsiToUnicode(fontA.font.lfFaceName, lBoxFont.font.lfFaceName, LF_FACESIZE);
				lBoxFont.dpi = fontA.dpi;
			#else
				lBoxFont.dpi = 0;
				ReadHex(&rptr, &lBoxFont, sizeof(lBoxFont));
			#endif
		}else{
			lBoxFont.dpi = 96;
		}
		FontHeight = lBoxFont.font.lfHeight;

		{							// NebvPPɌ炷
			BYTE bootdate = 0;

			rptr = CFGFindKey(&cfg, T("Boot"), buf, TSIZEOF(buf));
			if ( rptr != NULL ) ReadHex(&rptr, &bootdate, sizeof bootdate);
			GetLocalTime(&ltime);
			if ( bootdate == ltime.wDay ) coldboot = 0;
			bootdate = (BYTE)ltime.wDay;
			WriteHex(buf, &bootdate, sizeof bootdate);
			CFGReplaceLine(&cfg, 0, T("Boot"), buf);
		}
	}
									// mۂ̉
	{
		ACOFF moffset;
		AC_MAIL *acm;

		for ( moffset = AC_mails ; moffset ; moffset = acm->next ){
			acm = (AC_MAIL *)(cfgac.bottom + moffset);
			ThFree(&acm->list);
		}
	}
	memset(&Z_, 0, sizeof Z_);
	AC_mails = 0;
	AC_spams = 0;
	AC_ime = 0;
	X_VoiceDir = 0;
	X_VoiceResID = 0;
	X_minfo = X_libssl = X_spaminfo = 0;

	ThFree(&cfgstr);
	ThFree(&cfgac);
										// offset 0  NULL pɎg߂̏
	ThAppend(&cfgac, &offset, sizeof(DWORD));
	ThAppend(&cfgstr, &offset, sizeof(char));

	if (ResH) FreeLibrary(ResH);

	for ( off = offset ; CFGGetLine(&cfg, &offset, buf, TSIZEOF(buf)) ; off = offset ){
		TCHAR *bptr;
		bptr = tstrchr(buf, '=');
		if ( bptr == NULL ) continue;
		SkipSpaceB(buf, bptr);
		bptr++;
		SkipSpaceNC(&bptr);
										// l
		{
			const ITEMINT *ii;

			for ( ii = CustInt ; ii->name != NULL ; ii++ ){
				if ( tstrcmp(buf, ii->name) ) continue;
				*ii->value = GetNumberNC(&bptr);
				break;
			}
			if ( ii->name != NULL ) continue;
		}

		if ( !tstrcmp(buf, T("S_default")) ){
			q = CFGFixParam(bptr, &bptr);
			wsprintf(S_default, T(" %s "), q);
			if ( textlines < (MAXLINE - 1) ){
				tstrcpy(S_format[textlines], S_default);
				textlines++;
			}
			continue;
		}
		if ( !tstrcmp(buf, T("C_default")) ){
			GetColors(bptr, &C_default);
			continue;
		}
		if ( !tstrcmp(buf, T("C_telop")) ){
			GetColors(bptr, &C_telop);
			continue;
		}
		if ( !tstrcmp(buf, T("X_VoiceDir")) ){
			X_VoiceDir = ThAddCfgstrParam(&bptr);
			continue;
		}
		if ( !tstrcmp(buf, T("X_VoiceResID")) ){
			X_VoiceResID = ThAddCfgstrParam(&bptr);
			continue;
		}
		if ( !tstrcmp(buf, T("X_minfo")) ){
			X_minfo = ThAddCfgstrParam(&bptr);
			continue;
		}
		if ( !tstrcmp(buf, T("X_libssl")) ){
			X_libssl = ThAddCfgstrParam(&bptr);
			continue;
		}
		if ( !tstrcmp(buf, T("X_spaminfo")) ){
			X_spaminfo = ThAddCfgstrParam(&bptr);
			continue;
		}
		if ( !tstrcmp(buf, T("POP3")) ){
			if ( SetMails(&cfg, bptr, 0, &off) ) offset = off;
			continue;
		}
		if ( !tstrcmp(buf, T("APOP")) ){
			if ( SetMails(&cfg, bptr, ACMAIL_USEAPOP, &off) ) offset = off;
			continue;
		}
		if ( !tstrcmp(buf, T("IMAP4")) ){
			if ( SetMails(&cfg, bptr, ACMAIL_USEIMAP, &off) ) offset = off;
			continue;
		}
		if ( !tstrcmp(buf, T("spam")) ){
			SetMailfilter(bptr);
			continue;
		}
		if ( !tstrcmp(buf, T("imeon")) ){
			SetIMEchange(bptr, IME_CHANGE_ON);
			continue;
		}
		if ( !tstrcmp(buf, T("imeoff")) ){
			SetIMEchange(bptr, IME_CHANGE_OFF);
			continue;
		}
		if ( !tstrcmp(buf, T("imeasis")) ){
			SetIMEchange(bptr, IME_CHANGE_ASIS);
			continue;
		}
							// ڏ
		for( i = 0 ; i < MESS ; i++ ){
			if ( !tstricmp(buf, CustMes[i]) ){
				Z_[i] = ACGetMessage(bptr);
				GetAction(&cfg, Z_[i] ?
						&((ACTIONS *)(cfgac.bottom + Z_[i]))->next :
						&Z_[i], &offset, 1);
				break;
			}
		}
#if 0 // Font, Boot, DPos ŶŌ݂͖
		if ( i == MESS ){
			tstrcat(buf, T(": unknown name"));
			LogWrite(0, buf);
		}
#endif
	}
	if ( X_VoiceDir ){
		ResH = LoadLibraryEx(ThTOFFSETSTR(&cfgstr, X_VoiceDir),
				NULL, LOAD_LIBRARY_AS_DATAFILE);
	}
	if ( DispMesRate ){
		KillTimer(hMainWnd, 2);
		DispMesRate = 0;
	}
	if ( (X_telopq > 0) && (X_telopq <= 100) ){
		DispMesRate = INTERVAL - (X_telopq * 17) / 10;
		SetTimer(hMainWnd, 2, DispMesRate, TelopTimerProc);
	}
	if ( textlines == 0 ){
		textlines = 1;
		tstrcpy(S_format[0], S_default);
	}
	C_use = C_default;
	CFGClose(&cfg);
	SetTransparent();
	Cfgedit.edit = FALSE;
	MailCheckBreak = 0;

	SetHotKey(hMainWnd, KEYID_L, K_Lkey);
	SetHotKey(hMainWnd, KEYID_M, K_Mkey);
	SetHotKey(hMainWnd, KEYID_R, K_Rkey);

	UseCPodDLL( X_IME == 2 );
	InitSysParam();
	return coldboot;
}
