/*-----------------------------------------------------------------------------
	ClockPod / e_CAO									(c)TORO
-----------------------------------------------------------------------------*/
#define STRICT
#include <windows.h>
#include "CLOCKPOD.H"

/*-----------------------------------------------------------------------------
	zbgL[ݒ_CAO
-----------------------------------------------------------------------------*/
int		HotKey	 = 0;	// zbgL[ B16-B18:Sh
TCHAR	keytext[64];
//------------------------------------------------------------------ L[͑
LRESULT CALLBACK KeyProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch(message){
		case WM_GETDLGCODE:
			return DLGC_WANTALLKEYS | DLGC_BUTTON;
		case WM_SYSKEYDOWN:
		case WM_KEYDOWN: {
			BYTE pbKeyState[256];

			HotKey = LOWORD(wParam);
			keytext[0] = 0;
										// shift `FbN
			GetKeyboardState((LPBYTE)&pbKeyState);
			if ( pbKeyState[VK_SHIFT] & B7 ){
				HotKey |= B16;
				tstrcat(keytext, T("Shift+"));
			}
			if ( pbKeyState[VK_CONTROL] & B7 ){
				HotKey |= B17;
				tstrcat(keytext, T("Ctrl+"));
			}
			if ( pbKeyState[VK_MENU] & B7 ){
				HotKey |= B18;
				tstrcat(keytext, T("Alt+"));
			}
										// \̐ݒ
			GetKeyNameText((LONG)lParam, keytext + tstrlen(keytext), sizeof keytext-32);
			SetWindowText(hWnd, keytext);
			break;
		}
		case WM_PAINT: {
			PAINTSTRUCT ps;
			int size;
			TCHAR buf[TSIZEOF(keytext)];
			HGDIOBJ hOldFont;

			BeginPaint(hWnd, &ps);
			size = GetWindowText(hWnd, buf, TSIZEOF(buf));
			if ( size != 0 ){
				hOldFont = SelectObject(ps.hdc,
						(HFONT)SendMessage(GetParent(hWnd), WM_GETFONT, 0, 0));
				SetTextColor(ps.hdc, GetSysColor(COLOR_WINDOWTEXT));
				SetBkColor(ps.hdc, GetSysColor(COLOR_WINDOW));
				TextOut(ps.hdc, 4, 1, buf, size);
				SelectObject(ps.hdc, hOldFont);
			}
			EndPaint(hWnd, &ps);
			break;
		}
		case WM_SETTEXT:
			InvalidateRect(hWnd, NULL, TRUE);
//			default 
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}
//------------------------------------- L[̓͗p_CAOproc
#pragma argsused
INT_PTR CALLBACK KeyInputDlgBox(HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	UnUsedParam(lParam);
	switch (iMsg){
		case WM_INITDIALOG:
			SetWindowText(GetDlgItem(hDlg, IDP_KEY), keytext);
			SetForegroundWindow(hDlg);
			return TRUE;

		case WM_COMMAND:
			switch ( LOWORD(wParam) ){
				case IDOK:
					EndDialog(hDlg, TRUE);
					break;
				case IDCANCEL:
					EndDialog(hDlg, FALSE);
					break;
			}
			break;

		default:
			return FALSE;
	}
	return TRUE;
}
//------------------------------------- L[̓͗p_CAOĂяo
void Hotkeydlg(HWND hWnd, int id, const ITEMINT *item)
{
	WNDCLASS wcClass;
	CFG cfg;
	TCHAR *p;
	TCHAR buf[0x1000];

	if ( !CFGOpen(&cfg, cfgfile) ) return;

	HotKey = *item->value;
	keytext[0] = '\0';
	p = CFGFindKey(&cfg, item->name, buf, TSIZEOF(buf));
	if ( p != NULL ){
		p = tstrchr(p, ',');
		if ( p != NULL ) tstrcpy(keytext, p + 1);
	}

	wcClass.style			= CS_HREDRAW | CS_VREDRAW;
	wcClass.lpfnWndProc		= KeyProc;
	wcClass.cbClsExtra		= 0;
	wcClass.cbWndExtra		= DLGWINDOWEXTRA;
	wcClass.hInstance		= hMainInst;
	wcClass.hIcon			= NULL;
	wcClass.hCursor			= LoadCursor(NULL, IDC_ARROW);
	wcClass.hbrBackground	= (HBRUSH)(COLOR_WINDOW + 1);
	wcClass.lpszMenuName	= NULL;
	wcClass.lpszClassName	= T(KEYDLGCLASS);
											// NXo^
	RegisterClass(&wcClass);
	if ( FALSE != ExtDialogBox(hMainInst, MAKEINTRESOURCE(IDD_KEYINPUT),
			hWnd, KeyInputDlgBox) ){
		*item->value = HotKey;
		wsprintf(buf, T("%d,%s"), HotKey, keytext);
		CFGReplaceLine(&cfg, 0, item->name, buf);
		SetHotKey(hWnd, id, HotKey);
	}
	CFGClose(&cfg);
}
/*-----------------------------------------------------------------------------
	EBhEꗗ
-----------------------------------------------------------------------------*/
WNDPROC	OldListWndProc;
HWND	hWndListWnd = NULL, hWndindex = (HWND)(DWORD)0xfffffffe;
int		ListHidden;
//------------------------------------- ꗗ UI g
BOOL CALLBACK ListWindowsProc(HWND hWnd, LPARAM lParam)
{
	TCHAR title[0x800], parenttitle[0x800];
	HWND hParentWnd;

	if ( IsWindowVisible(hWnd) == FALSE ){
		if ( ListHidden == 0 ) return TRUE;
	}else{
		if ( ListHidden != 0 ) return TRUE;
	}

	if ( GetWindowText(hWnd, title, TSIZEOF(title)) ){
		LRESULT index;

		hParentWnd = GetParent(hWnd);
		if ( hParentWnd != NULL ){
			for (;;){
				HWND hPwnd = GetParent(hParentWnd);
				if ( hPwnd == NULL ) break;
				hParentWnd = hPwnd;
			}
			if ( GetWindowText(hParentWnd, parenttitle, TSIZEOF(parenttitle)) ){
				if ( (tstrlen(title) + tstrlen(parenttitle) + 4) < TSIZEOF(title) ){
					tstrcat(title, T("..."));
					tstrcat(title, parenttitle);
				}
			}
		}
		index = SendMessage((HWND)lParam, LB_ADDSTRING, 0, (LPARAM)title);
		if ( index != LB_ERR ){
			SendMessage((HWND)lParam, LB_SETITEMDATA, index, (LPARAM)hWnd);
			if ( hWnd == hWndindex ){
				SendMessage((HWND)lParam, LB_SETCARETINDEX, index, 0);
			}
		}
	}
	return TRUE;
}

void ResetWindowList(HWND hListWnd)
{
	int index = (int)SendMessage(hListWnd, LB_GETCARETINDEX, 0, 0);

	hWndindex = (index >= 0) ?
			(HWND)SendMessage(hListWnd, LB_GETITEMDATA, index, 0) :
			(HWND)(DWORD)0xfffffffe;

	SendMessage(hListWnd, LB_RESETCONTENT, 0, 0);
	EnumWindows(ListWindowsProc, (LPARAM)hListWnd);
}

//------------------------------------- ꗗ{
LRESULT CALLBACK ListWndProc(HWND hWnd, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	switch(iMsg){
		case WM_RBUTTONDOWN:
			return CallWindowProc(OldListWndProc, hWnd,
					WM_LBUTTONDOWN, wParam, lParam);
		case WM_RBUTTONUP:
			CallWindowProc(OldListWndProc, hWnd, WM_LBUTTONUP, wParam, lParam);
			WindowRupt(hWnd, (HWND)SendMessage(hWnd, LB_GETITEMDATA,
					SendMessage(hWnd, LB_GETCARETINDEX, 0, 0), 0), NULL);
			ResetWindowList(hWndListWnd);
			return 0;
		case WM_DESTROY:
			hWndListWnd = NULL;
			break;
	}
	return CallWindowProc(OldListWndProc, hWnd, iMsg, wParam, lParam);
}
//------------------------------------- ꗗ
void ListWindow(int all)
{
	ListHidden = all;
	if ( hWndListWnd == NULL ){
		hWndListWnd = CreateWindow(T("LISTBOX"), T("Window List"),
			WS_OVERLAPPEDWINDOW | WS_VSCROLL | WS_HSCROLL,
			CW_USEDEFAULT, CW_USEDEFAULT,
			400, 200, NULL, NULL, hMainInst, NULL);
		CenterWindow(hWndListWnd);
		OldListWndProc = (WNDPROC)SetWindowLongPtr(hWndListWnd,
				GWLP_WNDPROC, (LONG_PTR)ListWndProc);
	}
	if ( hWndListWnd != NULL ){
		ResetWindowList(hWndListWnd);
		ShowWindow(hWndListWnd, SW_SHOWNORMAL);
		ohWnd = hWndListWnd; //SetForegroundWindow(hListWnd);Ɠ
	}
}
/*-----------------------------------------------------------------------------
	MbZ[W
-----------------------------------------------------------------------------*/
INT_PTR CALLBACK InputDlgBox(HWND hDlg, UINT iMsg, WPARAM wParam, LPARAM lParam)
{
	switch (iMsg){
		case WM_CLOSE:
			DestroyWindow(hDlg);
			hSendWnd = NULL;
			break;

		case WM_INITDIALOG:
			CenterWindow(hDlg);
			SetWindowText(hDlg, (LPCTSTR)lParam);
			SendDlgItemMessage(hDlg, IDE_INPUT_USER, EM_LIMITTEXT, 32, 0);
			SendDlgItemMessage(hDlg, IDE_INPUT_MES, EM_LIMITTEXT, 80, 0);
			break;

		case WM_COMMAND:
			if ( LOWORD(wParam) == IDOK ){
				TCHAR title[MAX_PATH], user[MAX_PATH], mes[MAX_PATH];

				GetWindowText(hDlg, title, TSIZEOF(title));
				GetDlgItemText(hDlg, IDE_INPUT_USER, user, TSIZEOF(user));
				GetDlgItemText(hDlg, IDE_INPUT_MES, mes, TSIZEOF(mes));
				if ( tstrcmp(title, T(CAPTIONPOD)) == 0 ){
					SendPodSlot(user, mes);
				}else{
					SendMessenger(user, mes);
				}
				DestroyWindow(hDlg);
				EndDialog(hDlg, TRUE);
				hSendWnd = NULL;
				break;
			}
			if ( LOWORD(wParam) == IDCANCEL ){
				EndDialog(hDlg, FALSE);
				DestroyWindow(hDlg);
				hSendWnd = NULL;
				break;
			}
			break;

		default:
			return FALSE;
	}
	return TRUE;
}
