/*-----------------------------------------------------------------------------
	ClockPod / wb_												(c)TORO
-----------------------------------------------------------------------------*/
#include <ras.h>
#include "CHRTYPE.H"
#include "TOROWIN.H"
#include "SDK.H"
#include "CLOCKPOD.RH"
#include "THEAP.H"
#include "CFG.H"
#include "FALTDLG.H"

#ifdef __cplusplus
extern "C" {
#endif

#ifdef ONDLL
	#define DLLFUNC __declspec(dllexport)
#else
	#define DLLFUNC __declspec(dllimport)
#endif

#define AppName		"ClockPod"						// \tg
#define AppRegName	"Software\\TOROid\\ClockPod"	// gpWXg(gp)
													// m֎~̃X^C
#define NOTON		(WS_EX_TOOLWINDOW)
#define MaxMes		16								// ői[bZ[W
#define TRAYNAME	"Shell_TrayWnd"					// gC

#define MAXLINE		4			// ő\s
#define MAXLINEWIDTH	0x200	// ő\
#define INTERVAL	220			// TimerProc ̊Ԋu(ms)
#define MESLEN		0x200		// i[łő僁bZ[W
#define VRate		100			// ʂ̓ʒl
#define MAXRAS		16			// RAS őL\

#define BOOTMES 	"ClockPod (c)TORO"
#define ABOUTMES	T("ClockPod Ver") T(File_Version) T(" (c)TORO ") T(CopyrightYear)

#define MailSlotName	"\\mailslot\\CPODslot"
#define MessengerName	"\\mailslot\\messngr"

#define CAPTIONPOD	"Send ClockPod message"
#define CAPTIONMES	"Send messenger message"

#define WM_CP_EXECACTION (WM_USER + 0)	// Actions(Mail Thread ̒ʐM)
#define WM_TRAY_T		(WM_APP + 1060)	// Task Tray ̒ʒmM

#define TRAYID			0 // o[wv\pTip

typedef enum {
	zError,			zFlow,			zDeviceInfo,	zDeviceChg,
	zDriveChg,		zDevmodeChg,	zSettingChg,	zDisplayChg,
	zPower,			zPowerBroad,	zPowerLow,		zPrinting,
	zPrintDone,		zFontChange,	zSysColor,		zTimeChange,
	zCompacting,	zNoMail,		zNewMail,		zMailInfo,
	zRecvMail,
	zRasConnect,	zRasDConnect,	zCpodSlot,		zMessenger,
	zBoot,			zExit,			zEveryS,		zEveryM,
	zEveryH,		zLclick,		zMclick,		zNewTaskbar,
	zIME,			zEventLog,		zRasLap,		zDelTelop,
	zDelMail,		MESS,			zNoID
} IDS;

#define IMESTATUSREPORTCMD	0x1060
#define IMECHANGESTATUSCMD	0x2060
typedef enum { IME_OFF = 0xfc,IME_DIABLE,IME_CHECK,IME_NOTARGET,IME_CAPTIONCHANGE = 0x8000 } IMESTATUS;
enum HOTKEYID { KEYID_L,KEYID_M,KEYID_R };

typedef size_t STROFF;	// cfgstr gւ̃ItZbg
typedef size_t STROFFA;	// cfgstr g(ansi)ւ̃ItZbg
typedef size_t ACOFF;	// cfgac gACTIONS\̂ւ̃ItZbg
typedef struct {	// `
	ACOFF thenac,elseac;
} BACOFF;

#define GetCfgStr(stroff) ((TCHAR *)(char *)(cfgstr.bottom + (stroff)))
#define GetCfgDefStr(stroff, defaultstr) ((stroff) ? GetCfgStr(stroff) : (defaultstr))

#ifndef NIN_BALLOONSHOW
#define NIN_BALLOONSHOW         (WM_USER + 2)
#define NIN_BALLOONHIDE         (WM_USER + 3)
#define NIN_BALLOONTIMEOUT      (WM_USER + 4)
#define NIN_BALLOONUSERCLICK    (WM_USER + 5)
#endif

#ifdef _WIN64
	#define CLOCKPODDLLNAME "CLOCKPOD64.DLL"
#else
	#define CLOCKPODDLLNAME "CLOCKPOD.DLL"
#endif
//====================================================================== \
typedef struct {
	COLORREF fg;
	COLORREF bg;
} COLORS;

typedef struct {
	DWORD	lasttick;
	DWORD	interval;
	DWORD	RASinterval;
	STROFF	useRAS;
} INTERVALS;
									// Telop Ǘ\
typedef struct{
	int	id;			// bZ[W ID
	TCHAR	mes[MESLEN];// bZ[We
	DWORD	flag;		// DMES_xxx
}DMESSAGE;
#define DMES_FLAGS T("LTNDPSB_RCM")
// DMESSAGE.flag
#define DMES_LOG		B0
#define DMES_TELOP		B1
#define DMES_NEWTITLE	B2
#define DMES_DIALOG		B3
#define DMES_SENDCP		B4
#define DMES_SENDMSG	B5
#define DMES_BALLOON	B6
// B7 ͖gp
#define DMES_REPEAT		B8
#define DMES_COMPRESS	B9
#define DMES_MEARGE		B10

#define DMES_LOGTELOP	(DMES_LOG | DMES_TELOP)

typedef struct{
	LPCTSTR name;
	UINT flag; // SND_xxx(PlaySound)
}WAVESTACK;

struct CONNECTIONLIST {
	TCHAR pcname[64];
	TCHAR rasname[RAS_MaxEntryName + 1];
	DWORD time,lap;	// ڑԃJE^ oߎ,lap
	DWORD flag;		// B31:݃`FbNp	B0:LongTime
};
#define CLF_LONGTIMED	B0
#define CLF_CHECK		B31

struct EVENTLOGLIST {
	const TCHAR *name;
	HANDLE	hLog;
	DWORD	count;
};

struct CONFIGEDIT {		// `t@CҏWp
	BOOL				edit;			// ҏW
	PROCESS_INFORMATION	pi;				// ̏IĎ
	FILETIME			ConfigStamp;	// `t@C̍XVmF
};
//============================================================== `\
enum ACS {	AC_null, AC_break, AC_message, AC_color, AC_wave,
			AC_exec, AC_compare, AC_interval, AC_mailchk, AC_delete,
			AC_value, AC_cvalue, AC_if, AC_find, AC_close, AC_pointinfo,
			ACSS};

typedef struct tagACTIONS {		// p ===================================
	ACOFF next;					// next offset, 0:last
	DWORD type;					// ̍\̂̎ = 0
} ACTIONS;

typedef struct tagAC_MESSAGE {	// Message ==============================
	ACTIONS	c;					// p
	DWORD	flag;				// IvVtO DMES_xxx
	STROFF	message;
} AC_MESSAGE;

typedef struct tagAC_COLOR {	// Color ===================================
	ACTIONS	c;					// p
	COLORS	color;
} AC_COLOR;

typedef struct tagAC_WAVE {		// Wave ====================================
	ACTIONS	c;					// p
	DWORD	flag;				// IvVtO ACWAV_xxx
	STROFF	wave;
} AC_WAVE;
#define ACWAV_FLAGS T("FL")
#define ACWAV_FORCE	B0
#define ACWAV_LOOP	B1

typedef struct tagAC_EXEC {		// Exec ====================================
	ACTIONS	c;					// p
	STROFF	cmd;
} AC_EXEC;

typedef struct tagAC_COMPARE {	// Compare(Find) ============================
	ACTIONS	c;					// p
	STROFF	str1;
	STROFF	str2;
	BACOFF	ac;
} AC_COMPARE;

typedef struct tagAC_IF {		// If =================================
	ACTIONS	c;					// p
	STROFF	form;
	BACOFF	ac;
} AC_IF;

typedef struct tagAC_INTERVAL {	// Interval ================================
	ACTIONS	c;					// p
	INTERVALS	i;
	BACOFF	ac;
} AC_INTERVAL;

#define ACMC_FLAGS	T("ITRBC")
#define ACMC_USEZMAIL	B0	// I Z_MailInfo gp
#define ACMC_TIMER		B1	// T Interval Check
#define ACMC_NORAS		B2	// R No RAS Check
#define ACMC_BOOT		B3	// B Boot  Check
#define ACMC_CONNECT	B4	// C Connect  Check
typedef struct tagAC_MAILCHK {	// MailCheck ===============================
	ACTIONS	c;					// p
	DWORD	flag;	// ACMC_xxx
	STROFF	account;
} AC_MAILCHK;

typedef struct tagAC_DELETE {	// Delete ===================================
	ACTIONS	c;					// p
	STROFF	type;				// ebv
} AC_DELETE;

typedef struct tagAC_VALUE {	// Value ===================================
	ACTIONS	c;					// p
	STROFF	name;				// ϐ
	STROFF	param;				// e
} AC_VALUE;

typedef AC_COMPARE AC_FIND;		// Find ===================================

#define ACMAIL_FLAGS	T("NBCS")
#define ACMAIL_RELCHECK		B0	// N 0:!0`FbN	1:`FbN
#define ACMAIL_BOOTCHECK	B1	// B Nɒׂ
#define ACMAIL_CONNECTCHECK	B2	// C ڑɒׂ
#define ACMAIL_USESSL		B3	// S OpenSSLgĐڑ
#define ACMAIL_USEIMAP		B7	// IMAP4g
#define ACMAIL_USEAPOP		B8	// 0=POP3 1=APOP
typedef struct tagAC_MAIL {	// Mail `FbN ==================================
	ACOFF	next;				// next offset,0:last
	INTERVALS i;
						// ---------------- Œl
	STROFF	id;			// ID name
	int		flags;		// eݒ ACMAIL_xxx
	STROFFA	ip;			// IP address
	int		port;		// service port
	STROFFA	user;		// user ID
	STROFFA	pwd;		// user password
	STROFFA	mailbox;	// IMAP4 mailbox 
						// ---------------- ϐ
	BOOL	check;		// `FbN\
	int		allcount;	// S[
	int		unseen;		// ǃ[
	int		spams;		// oXp
	SYSTEMTIME last;	// ŏIXV
	ThSTRUCT list;		// ꗗ
} AC_MAIL;

typedef struct tagAC_SPAM {	// spam `FbN ==================================
	ACOFF	next;		// next offset,0:last
	STROFF	id;			// ID name
	STROFFA	header;
	STROFFA	keyword;
	int		points;		// spam points
} AC_SPAM;


typedef struct tagAC_IMECHANGE {	// IME change(Find) =======================
	ACOFF	next;		// next offset,0:last
	int		mode;		// 0:off !0:on
	STROFF	caption;	// ^Cgo[
	STROFF	classname;	// NX
} AC_IMECHANGE;
enum IMECHANGETYPE { IME_CHANGE_OFF = 0,IME_CHANGE_ON,IME_CHANGE_ASIS };

typedef struct {
	TCHAR	*name;			// x
	int		*value;			// o^
} ITEMINT;

					// ExecAction(LPARAM:ACTIONS *,WPARAM:int)
typedef struct {
	ACTIONS *ac;
	int id;
	const TCHAR *param;
} CPESTRUCT;

typedef struct {
	LOGFONT font;
	int dpi;
} LOGFONTWITHDPI;

typedef struct {
	LOGFONTA font;
	int dpi;
} LOGFONTWITHDPIA;

//============================================================== O[oϐ
#define GLOBALEXTERN
#include "CLK_GVAR.C"
#undef GLOBALEXTERN
//======================================================================== ֐
// CLOCKPOD.C
extern void Init(void);
extern void Close(void);
extern const TCHAR AppNameHolderStr[];
// CLK_AC.C
extern BOOL tPlaySoundMain(LPCTSTR wave,UINT opt);
extern void SendPodSlot(const TCHAR *dest,const TCHAR *message);
extern void SendMessenger(const TCHAR *dest,const TCHAR *message);
extern void SetTime(void);
extern void ResetTime(void);
extern DWORD GetPassSec(DWORD tick);
extern BOOL CheckInterval(INTERVALS *in);
extern BOOL ExecAction(ACTIONS *ac,int id,const TCHAR *param);
extern BOOL ACdeleteMain(int id);
// CLK_CUST.C
extern int  USEFASTCALL GetNumber(LPCTSTR *ptr);
#define GetNumberNC(str) GetNumber((LPCTSTR *)str)
extern void USEFASTCALL MakeCfgFilename(TCHAR *filename,const TCHAR *param);
extern int USEFASTCALL Customize(int mode);
extern void USEFASTCALL SkipSpaceB(TCHAR *b,TCHAR *p);
// CLK_DLG.C
extern void Hotkeydlg(HWND hWnd,int id,const ITEMINT *item);
extern void ListWindow(int all);
extern INT_PTR CALLBACK InputDlgBox(HWND hDlg,UINT iMsg,WPARAM wParam,LPARAM lParam);
// CLK_INFO.C
extern void BatteryCheckMain(void);
extern void ReadBatteryInfo(void);
extern void DevChange(WPARAM wParam, LPARAM lParam);
extern BOOL AddConnection(TCHAR *pcname,TCHAR *rasname);
extern void DelConnection(TCHAR *pcname,TCHAR *rasname);
extern BOOL Rasnames(TCHAR *src,TCHAR *pcname,TCHAR *rasname);
extern void RasCheckMain(void);
extern void GetIMEinfo(DWORD param);
extern int GetCPUusing(void);
extern void GetCPUTemp(void);
extern BOOL CallHDTEMP(TCHAR driveno,TCHAR *result);
extern void GetGPUInfomation(TCHAR type,TCHAR *destbuf);
extern void GetMemoryInfo(TCHAR type,TCHAR *destbuf);
extern void GetCpuClock(void);
extern void SetDiskInformainMenu(HMENU hParentMenu);

// CLK_MAIL.C
extern void StartMailCheck(int flag,int id);
// CLK_MAIN.C
extern void DrawWindow(HWND hWnd);
extern LRESULT CALLBACK WndProc(HWND hWnd, UINT message,WPARAM wParam, LPARAM lParam);
// CLK_MENU.C
extern void WindowRupt(HWND hWnd,HWND phWnd,POINT *pos);
extern void WindowMenu(HWND hWnd,int posmode);
// CLK_MSG.C
extern void LogWrite(DWORD id,const TCHAR *message);
extern TCHAR *tsprintf(TCHAR *dest,const TCHAR *fmt,const TCHAR *params);
extern void SetMessage(int id,const TCHAR *mes,DWORD flag,const TCHAR *params);
extern void DeleteTelop(int no);
extern void ExecDelTelop(int i);
// CLK_SUB.C
extern void CenterWindow(HWND hWnd);
extern void DrawFocusWindow(HWND hWnd,BOOL show);
extern HWND GetPWindow(void);
extern HWND GetWindowFromPoint(POINT sPos);
extern void GetWndStyle(void);
extern void InitSysParam(void);
extern void MoveClock(HWND hWnd);
extern void PodMail(TCHAR *Status,DWORD size);
extern void ReleaseCap(HWND hWnd);
extern void SetHotKey(HWND hWnd,int id,int hotkey);
extern void SetTransparent(void);
extern int TrackPopupMenuSx(HMENU popup,int x,int y,HWND hWnd);
extern void USEFASTCALL Z_ExecAction(int ID,const TCHAR *param);
extern void SetForegroundWindow98(HWND hWnd);
extern void UseCPodDLL(int useflag);
extern void SetDefaultCursor(HWND hWnd,const TCHAR *iconname);
extern void ShowCarendar(HWND hWnd);
extern void CloseCarendar(void);
extern BOOL TrayMessage(HWND hWnd,DWORD Message,WORD Icon,const TCHAR *TipStr,const TCHAR *BalloonStr);
extern int GetMonitorDPI(HWND hWnd);
extern char *strlimcpy(char *deststr,const char *srcstr,size_t maxlength);
extern WCHAR *wcslimcpy(WCHAR *deststr,const WCHAR *srcstr,size_t maxlength);
#ifdef UNICODE
  #define tstrlimcpy wcslimcpy
#else
  #define tstrlimcpy strlimcpy
#endif
extern INT_PTR ExtDialogBoxParam(HANDLE hinst,const TCHAR *lpszTemplate,HWND hwndOwner,DLGPROC dlgprc,LPARAM lParamInit);
extern HWND ExtCreateDialogParam(HANDLE hinst,const TCHAR *lpszTemplate,HWND hwndOwner,DLGPROC dlgprc,LPARAM lParamInit);
#define ExtDialogBox(hinst,lpszTemplate,hwndOwner,dlgprc) ExtDialogBoxParam(hinst,lpszTemplate,hwndOwner,dlgprc,0)

// CLK_TIME.C
extern void CALLBACK TimerProc(HWND hWnd,UINT uMsg,UINT_PTR idEvent,DWORD dwTime);
extern void CALLBACK TelopTimerProc(HWND hWnd,UINT uMsg,UINT_PTR idEvent,DWORD dwTime);
// MD5.C
extern void MDString(char *string);

// CPODDLL.C
extern DLLFUNC void WINAPI HookSwitch(BOOL sw);

// CLK_ACC.CPP
extern void GetStringFromPoint(POINT *pos,WCHAR *name,WCHAR *value,DWORD size);


#ifdef UNICODE
extern int USEFASTCALL GetNumberA(LPCSTR *ptr);
extern STROFF USEFASTCALL ThAddStringA(ThSTRUCT *TH,const char *data);
#else
#define GetNumberA(pptr) GetNumber(pptr)
#define ThAddStringA(pptr) ThAddString(pptr)
#endif

#ifdef __cplusplus
}
#endif
