/*-----------------------------------------------------------------------------
	`t@CpbP[W ȈՔ							(c)TORO 2000
-----------------------------------------------------------------------------*/
#define STRICT
#include <windows.h>
#include <string.h>
#include "TOROWIN.H"
#include "TCFG.H"

//======================================================================== Gp
/*-------------------------------------
	s(\0,\a,\d)H

RET:	==0 :EOL	!=0 :Code
--------------------------------------*/
BYTE USEFASTCALL IsEOL(char **str)
{
	BYTE code;

	code = **str;
	if ( code == '\0' ) return '\0';
	if ( code == 0xd ){
		if ( *(*str + 1) == 0x0a ) (*str)++;
		return '\0';
	}
	if ( code == 0xa ){
		if ( *(*str + 1) == 0x0d ) (*str)++;
		return '\0';
	}
	return code;
}
/*-------------------------------------
	(space, tabjXLbv

RET:	==0 :EOL	!=0 :Code
--------------------------------------*/
BYTE USEFASTCALL SkipSpace(char **str)
{
	BYTE code;

	for (;;){
		code = IsEOL(str);
		if ( (code != ' ') && (code != '\t') ) break;
		(*str)++;
	}
	return code;
}
//------------------------------------- s󔒂(b:擪, p:)
void USEFASTCALL SkipSpaceB(char *b, char *p)
{
	while( b < p ){
		if ( (*p == ' ') || (*p == '\t') ){
			p--;
			continue;
		}
		break;
	}
	*(p + 1) = '\0';
}
//============================================================ `t@C
//------------------------------------- `t@Cǂݍ
BOOL CFGOpen(CFG *cfg, const TCHAR *filename)
{
	HANDLE hFile;

	cfg->bottom = NULL;
	cfg->size = 0;
	cfg->write = 0;
	tstrcpy(cfg->filename, filename);

	hFile = CreateFile(filename, GENERIC_READ, FILE_SHARE_READ, NULL,
			OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL);
	if ( hFile == INVALID_HANDLE_VALUE ) return FALSE;
	cfg->size = GetFileSize(hFile, NULL);
	cfg->bottom = HeapAlloc(GetProcessHeap(), 0, cfg->size + 256);
	ReadFile(hFile, cfg->bottom, cfg->size, &cfg->size, NULL);
	CloseHandle ( hFile );

	memset(cfg->bottom + cfg->size, 0, 256);
	return TRUE;
}
//------------------------------------- `t@C
BOOL CFGClose(CFG *cfg)
{
	HeapFree( GetProcessHeap(), 0, cfg->bottom);
	return TRUE;
}
/*-------------------------------------
	w offset Asǂݍ
	string ɏށB
	offset ɂ͎̍s̐擪
-------------------------------------*/
BOOL CFGGetLine(CFG *cfg, DWORD *offset, char *string)
{
	char *bottom, *p, *end = NULL;

	bottom = cfg->bottom + *offset;
	if ( !*bottom ) return FALSE;
											// 擪̋󔒂폜 ---------------
	SkipSpace(&bottom);
	p = bottom;
											// s&Rǧ ------------
	for ( ; *p ; p++ ){
		if ( (*p == ';') && !end ){				// Rg
			end = p;
			continue;
		}
		if ( (*p == '\r') || (*p == '\n') ){	// CR/LF
			if ( !end ) end = p;
			p++;
			while ( (*p == '\r') || (*p == '\n') ) p++;
			break;
		}
	}
	*offset = (DWORD)(p - cfg->bottom);
	if ( !end ) end = p;
											// s̋󔒂폜 ---------------
	while ( (end > bottom) && (*(end - 1) == ' ') )	end--;
											//  & TAB  ----------------
	for ( ; bottom < end ; bottom++ ){
		if ( *bottom == '\t' ) continue;
		*string++ = *bottom;
	}
	*string = 0;
	return TRUE;
}
//------------------------------------- p[^𒊏o
char *CFGFixParam(char *string, char **next)
{
	char *p, *q;

	SkipSpace(&string);
	p = string;
	while ( *p && (*p != ',') ) p++;
	q = p;
	if ( *p == ',' ) p++;
	while ( (q > string) && (*(q - 1) == ' ') ) q--;
	*q = 0;

	if ( next ) *next = p;
	return string;
}
