/*-----------------------------------------------------------------------------
	Security ֌W									Copyright (c)2001 TORO
-----------------------------------------------------------------------------*/
#define	 STRICT
#include <windows.h>
#include "TOROWIN.H"
#include "TSECU.H"
/*-----------------------------------------------------------------------------
	Everyone Access p Security Descriptor 쐬
-----------------------------------------------------------------------------*/
PSECURITY_DESCRIPTOR MakeEveryoneSecurity(void)
{
	PSECURITY_DESCRIPTOR pSD;
							// security descriptor 쐬
	pSD = (PSECURITY_DESCRIPTOR)
			LocalAlloc(LMEM_FIXED, SECURITY_DESCRIPTOR_MIN_LENGTH);
	if ( pSD == NULL ) return NULL;
	if ( !InitializeSecurityDescriptor(pSD, SECURITY_DESCRIPTOR_REVISION) ){
		goto error;
	}
							// NULL DESCRIPTOR (Everyone) 쐬
	if ( !SetSecurityDescriptorDacl(pSD, TRUE, NULL, FALSE)){
		goto error;
	}
	return pSD;
error:
	LocalFree((HLOCAL)pSD);
	return NULL;
}
/*-----------------------------------------------------------------------------
	ACL ɃJg[Űǉ
-----------------------------------------------------------------------------*/
#ifdef USEAddAllowUserAce
BOOL USEFASTCALL AddAllowUserAce(PACL pACL, DWORD mode)
{
	SID_NAME_USE sidnameuse;
	char	domainname[0x400];
	char	username[0x400];
	DWORD	domainsize = sizeof domainname;
	DWORD	usersize = sizeof username;
	DWORD	SIDsize = 0x400;
	PSID	pSID;

	pSID = (PSID)LocalAlloc(LMEM_FIXED, SIDsize);
	if ( pSID == NULL) return FALSE;

	GetUserName(username, &usersize);
	if ( LookupAccountName(NULL, username, pSID, &SIDsize,
			domainname, &domainsize, &sidnameuse) == FALSE ){
		goto error;
	}
											// ACL  SID ǉ
	if ( AddAccessAllowedAce(pACL, ACL_REVISION2, mode, pSID) == FALSE ){
		goto error;
	}
	LocalFree(pSID);
	return TRUE;
error:
	LocalFree(pSID);
	return FALSE;
}
#endif

/*-----------------------------------------------------------------------------
	ACL Ɏw肵 Well - known AJEg̋ǉ
-----------------------------------------------------------------------------*/
#ifdef USEAddAllowWellknownAce
BOOL USEFASTCALL AddAllowWellknownAce(PACL pACL, DWORD mode, DWORD a1, DWORD a2)
{
	SID_IDENTIFIER_AUTHORITY siaNTAuthority = {SECURITY_NT_AUTHORITY};
	PSID	pSID;
	BOOL	result;

	if ( AllocateAndInitializeSid(&siaNTAuthority, (BYTE)(a2 ? 2 : 1), a1, a2,
			0, 0, 0, 0, 0, 0, &pSID) == FALSE ){
		return FALSE;
	}
	result = AddAccessAllowedAce(pACL, ACL_REVISION2, mode, pSID);
	FreeSid(pSID);
	return result;
}
#endif
