/*-----------------------------------------------------------------------------
	Stack Heap Functions						Rel.2005/06	(c)TORO
-----------------------------------------------------------------------------*/
#define STRICT
#include <windows.h>
#include <string.h>
#include "TOROWIN.H"
#include "TTHEAP.H"

//-----------------------------------------------------------------------------
void ThInit(ThSTRUCT *TH)
{
	TH->bottom = NULL;
}
//-----------------------------------------------------------------------------
BOOL ThFree(ThSTRUCT *TH)
{
	BOOL result = TRUE;

	if (TH->bottom != NULL){
		result = HeapFree(GetProcessHeap(), 0, TH->bottom);
		TH->bottom = NULL;
	}
	return(result);
}
//-----------------------------------------------------------------------------
size_t ThAddString(ThSTRUCT *TH, char *data)
{
	size_t size;
	size_t offset;
										// VK
	if (TH->bottom == NULL){
		TH->bottom = HeapAlloc(GetProcessHeap(), 0, ThSTEP);
		if (TH->bottom == NULL) return INVALID_VALUE(size_t);
		TH->top = 0;
		TH->size = ThSTEP;
	}
										// s̃m
	size = strlen(data) + 1;
	while ( (TH->top + size + 1) > TH->size ){
		LPSTR *p;

		p = HeapReAlloc( GetProcessHeap(), 0, TH->bottom, TH->size + ThSTEP);
		if (p == NULL) return INVALID_VALUE(size_t);
		TH->bottom = (void *)p;
		TH->size += ThSTEP;
	}
										// ۑ
	offset = TH->top;
	memcpy(TH->bottom + offset, data, size);
	TH->top += size;
	*(TH->bottom + TH->top) = '\0';
	return offset;
}
